<?php
/**
 * This file is part of 
 * Kimai - Time Tracking For Designers // http://www.kimai.org
 * (c) 2006/07 Torsten Hoeltge
 * 
 * Kimai is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; Version 2 of June 1991.
 * 
 * Kimai is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Kimai; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 * @global string  $link database connection
 * 
 * from config include:
 * @global string $server_hostname
 * @global string $server_database
 * @global string $server_username
 * @global string $server_password
 * @global string $server_prefix
 * @global string $language de, en, nl ....
 * 
 * @global array   $lang localization
 * @global array  $conf user configuration                                                          
 * @global integer $now                                                          
 * 
 */

// =============================
// = Smarty (initialize class) =
// ============================= 
require_once('../includes/smarty/Smarty.class.php');
$tpl = new Smarty();
$tpl->template_dir = '../templates/';
$tpl->compile_dir  = '../includes/smarty/templates_c';
$tpl->cache_dir    = '../includes/smarty/cache';
$tpl->config_dir   = '../includes/smarty/configs';

// ==================================
// = implementing standard includes =
// ==================================
include('../includes/basics.php');

$usr = checkUser();

// HINWEIS:
// Jedes neue update schreibt seine Versionsnummer in die Datenbank.
// Beim nächsten Update kommt dann in der Datei /includes/var.php die neue V-Nr. mit.
// der updater.php weiss dann welche Aenderungen an der Datenbank vorgenommen werden muessen. 
checkDBversion("..");

$conf = get_config($usr['usr_ID']);
$tpl->assign('conf',$conf);
$tpl->assign('usr',$usr);
$tpl->assign('browser', get_agent());

if ($conf['lang'] != "") {
    $language = $conf['lang'];
}
require_once( "../language/${language}.php" );
$tpl->assign('lang',$lang);

// ============================================
// = initialize currently displayed timespace =
// ============================================
$timespace = get_timespace($usr['usr_ID']);
$in = $timespace[0];
$out = $timespace[1];

// ===============================================
// = get time for the probably running stopwatch =
// ===============================================
$current_timer = get_current_timer($usr['usr_ID']);

// ==========================
// = display customer table =
// ==========================
$arr_knd = get_arr_knd_with_time($usr['usr_grp'],$usr['usr_ID'],$in,$out);
if (count($arr_knd)>0) {
    $tpl->assign('arr_knd', $arr_knd);
} else {
    $tpl->assign('arr_knd', '0');
}
$tpl->assign('filter', $conf['filter']);
$tpl->assign('customerhack', $customerhack);
$tpl->assign('knd_display', $tpl->fetch("core/knd.tpl"));

// =========================
// = display project table =
// =========================
$arr_pct = get_arr_pct_with_time($usr['usr_grp'],$usr['usr_ID'],$in,$out);
if (count($arr_pct)>0) {
    $tpl->assign('arr_pct', $arr_pct);
} else {
    $tpl->assign('arr_pct', '0');
}
$tpl->assign('pct_display', $tpl->fetch("core/pct.tpl"));

// ========================
// = display events table =
// ========================
$arr_evt = get_arr_evt_with_time($usr['usr_grp'],$usr['usr_ID'],$in,$out);
if (count($arr_evt)>0) {
    $tpl->assign('arr_evt', $arr_evt);
} else {
    $tpl->assign('arr_evt', '0');
}
$tpl->assign('evt_display', $tpl->fetch("core/evt.tpl"));

// ==========================
// = display timesheet area =
// ==========================
$total = intervallApos(get_zef_time($usr['usr_ID'],$in,$out));
$arr_zef = get_arr_zef($usr['usr_ID'],$in,$out,1);
if (count($arr_zef)>0) {
    $tpl->assign('arr_zef', $arr_zef);
} else {
    $tpl->assign('arr_zef', 0);
}
$tpl->assign('total', $total);
$tpl->assign('zef_display', $tpl->fetch("core/zef.tpl"));

SetRecordConfig($arr_zef,$usr['usr_ID']);

$tpl->assign('bumperAction', "startRecord()");

// select for projects
      $sel = makeSelectBox("pct",$usr['usr_grp']);
      $tpl->assign('sel_pct_names', $sel[0]);
      $tpl->assign('sel_pct_IDs',   $sel[1]);

// select for events
      $sel = makeSelectBox("evt",$usr['usr_grp']);
      $tpl->assign('sel_evt_names', $sel[0]);
      $tpl->assign('sel_evt_IDs',   $sel[1]);

// preselected
      $tpl->assign('lastProject', $conf['lastProject']);
      $tpl->assign('lastEvent',   $conf['lastEvent']);

// ========================
// = Bumper and selectors =
// ========================
if ($conf['recordingstate'] || !$conf['zef_anzahl']) {
    $recorder = $tpl->fetch("core/record.tpl");
    $tpl->assign('recordingstate', 0);
} else {
    $recorder = $tpl->fetch("core/stop.tpl");
    $tpl->assign('recordingstate', 1);
}
$tpl->assign('recorder', $recorder);

// =======================================
// = Display date and time in the header =
// =======================================
$week = array($lang['day_short_sun'], $lang['day_short_mon'], $lang['day_short_tue'], $lang['day_short_wed'], $lang['day_short_thu'], $lang['day_short_fri'], $lang['day_short_sat']);

$weekday=date("w",time());
$wd=$week[$weekday];
$today=date("d.m.Y",time());

$nextweekday=date("w",time()+86400);
$nextday= $week[$nextweekday].date(" - d.m.Y",time()+86400);

$datetime = "<span id=\"display_day\">$wd - $today</span><br />
<img src=\"../skins/".$conf['skin']."/grfx/n_uhr.gif\" width=\"14\" height=\"13\" alt=\"~~Uhr\" />
<span id=\"n_uhr\"></span> &nbsp; 
<img src=\"../skins/".$conf['skin']."/grfx/auge.png\" width=\"16\" height=\"13\" alt=\"~~Current Timespace Summary\" /> 
<strong id=\"viewtotal_top\">$total</strong>";

// ===========================
// = DatePicker localization =
// ===========================
$localized_DatePicker ="";

$localized_DatePicker .= sprintf ("Date.dayNames = ['%s', '%s', '%s', '%s', '%s', '%s', '%s'];\n" 
,$lang['day_sun'],$lang['day_mon'],$lang['day_tue'],$lang['day_wed'],$lang['day_thu'],$lang['day_fri'],$lang['day_sat']);

$localized_DatePicker .= sprintf ("        Date.abbrDayNames = ['%s', '%s', '%s', '%s', '%s', '%s', '%s'];\n" 
,$lang['day_short_sun'],$lang['day_short_mon'],$lang['day_short_tue'],$lang['day_short_wed'],$lang['day_short_thu'],$lang['day_short_fri'],$lang['day_short_sat']);

$localized_DatePicker .= sprintf ("        Date.monthNames = ['%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s'];\n",
$lang['month_1'],$lang['month_2'],$lang['month_3'],$lang['month_4'],$lang['month_5'],$lang['month_6'],$lang['month_7'],$lang['month_8'],$lang['month_9'],$lang['month_10'],$lang['month_11'],$lang['month_12']);

$localized_DatePicker .= sprintf ("        Date.abbrMonthNames = ['%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s'];",$lang['month_short_1'],$lang['month_short_2'],$lang['month_short_3'],$lang['month_short_4'],$lang['month_short_5'],$lang['month_short_6'],$lang['month_short_7'],$lang['month_short_8'],$lang['month_short_9'],$lang['month_short_10'],$lang['month_short_11'],$lang['month_short_12']);

// ==============================
// = assign smarty placeholders =
// ==============================
$tpl->assign('current_timer_hour', $current_timer['hour']);
$tpl->assign('current_timer_min',  $current_timer['min'] );
$tpl->assign('current_timer_sec',  $current_timer['sec'] );

$from = date("j-n-Y",$in);
$from = explode("-",$from);
$to = date("j-n-Y",$out);
$to = explode("-",$to);

$tpl->assign('fromDay',   $from[0]);
$tpl->assign('fromMonth', $from[1]);
$tpl->assign('fromYear',  $from[2]);
$tpl->assign('toDay',     $to[0]);
$tpl->assign('toMonth',   $to[1]);
$tpl->assign('toYear',    $to[2]);
                         
$tpl->assign('version',   $version);
$tpl->assign('database',  $server_database);
$tpl->assign('timespace_warning', timespace_warning($in,$out));
$tpl->assign('datetime', $datetime);
$tpl->assign('nextday', $nextday);
$tpl->assign('localized_DatePicker', $localized_DatePicker);
$tpl->assign('language', $language);

$tpl->display('core/main.tpl');

mysql_close();
?>
