<?php
/**
 * This file is part of 
 * Kimai - Time Tracking For Designers // http://www.kimai.org
 * (c) 2006/07 Torsten Hoeltge
 * 
 * Kimai is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; Version 2 of June 1991.
 * 
 * Kimai is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Kimai; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 * @global string  $link database connection
 * 
 * 
 * from config include:
 * @global string $server_hostname
 * @global string $server_database
 * @global string $server_username
 * @global string $server_password
 * @global string $server_prefix
 * @global string $language de, en, nl ....
 * 
 * @global array   $lang localization
 * @global array  $conf user configuration                                                          
 * @global integer $now                                                      
 * 
 */

error_reporting(0); // FPDF throws some notices
require('../includes/kimaiprint.php');
require('../includes/basics.php');
require( "../language/${language}.php" );

$usr = checkUser();

$conf = get_config($usr['usr_ID']);

// Filter Provisorium fuer Klaus //////////
// FPKF
$filterID = $conf['filter'];
// wenn der richtige filter drin ist -> 
// alle Zeilen mit FPKF rausschmeissen!
//
///////////////////////////////////////////


// ============================================
// = initialize currently displayed timespace =
// ============================================
$timespace = get_timespace($usr['usr_ID']);
$in  = $timespace[0];
$out = $timespace[1];

if (!$filterID || !$customerhack) { // FPKF

    // ==========================
    // = display customer table =
    // ==========================
    $arr_knd = get_arr_knd_with_time($usr['usr_grp'],$usr['usr_ID'],$in,$out);

    $j=0;
    foreach ($arr_knd as $row) {
		if ($conf['charset']=="utf-8") {
			$knd_name = $row['knd_name'];
			$zeit     = $row['zeit'];
		} else {
			$knd_name = utf8_encode($row['knd_name']);
			$zeit     = utf8_encode($row['zeit']);   	
		}
        $knd_data[$j] = array($knd_name,$zeit);
        $j++;
    }

    // =========================
    // = display project table =
    // =========================
    $arr_pct = get_arr_pct_with_time($usr['usr_grp'],$usr['usr_ID'],$in,$out);

    $j=0;
    foreach ($arr_pct as $row) {
        $pct_knd = $row['pct_name'] . " (" .$row['knd_name']. ")";
		if ($conf['charset']=="utf-8") {
			$zeit     = $row['zeit'];
		} else {
			$pct_knd = utf8_encode($pct_knd);
			$zeit    = utf8_encode($row['zeit']);   	
		}
        $pct_data[$j] = array($pct_knd,$zeit);
        $j++;
    }


    // ========================
    // = display events table =
    // ========================
    $arr_evt = get_arr_evt_with_time($usr['usr_grp'],$usr['usr_ID'],$in,$out);

    $j=0;
    foreach ($arr_evt as $row) {
		if ($conf['charset']=="utf-8") {
			$evt_name = $row['evt_name'];
			$zeit     = $row['zeit'];
		} else {
			$evt_name = utf8_encode($row['evt_name']);
			$zeit     = utf8_encode($row['zeit']);   	
		}
        $evt_data[$j] = array($evt_name,$zeit);
        $j++;
    }

} // FPKF



// ==================================================
// = get timesheet entries and push into data array =
// ==================================================
$arr_zef = get_arr_zef($usr['usr_ID'],$in,$out,0);
$j=0; $total_secs=0;
foreach ($arr_zef as $row) {
    
   if ( (!$filterID) || ($filterID == $row['pct_kndID']) || (!$customerhack) ) { // FPKF
	
			if ($conf['charset']=="utf-8") {
                $knd_name =    $row['knd_name']; 
                $pct_name =    $row['pct_name']; 
                $evt_name =    $row['evt_name'];
                $zef_comment = $row['zef_comment'];
			} else {
                $knd_name =    utf8_encode($row['knd_name']); 
                $pct_name =    utf8_encode($row['pct_name']); 
                $evt_name =    utf8_encode($row['evt_name']);
                $zef_comment = utf8_encode($row['zef_comment']);  	
			}	
               
            $zef_data[$j] = array(
                                date("d.m.",$row['zef_in']), 
                                date("H:i",$row['zef_in']), 
                                date("H:i",$row['zef_out']), 
                                intervallApos($row['zef_time']), 
                                $knd_name, 
                                $pct_name, 
                                $evt_name,
                                $zef_comment
                            );
            $j++;
            $total_secs+=$row['zef_time'];
            
    } // FPKF
}


// =======================================
// = get total time of displayed entries =
// =======================================
$total = intervallApos($total_secs);

// =====================================
// = define title and table header row =
// =====================================
// TODO: get the header from locale file - solve problem with umlauts
// fuck! fpdf can't do utf-8!
$date_format="j.n.Y";
if ($language == "de" && ($conf['lang'] == "de" || $conf['lang'] == "")) {
	$title = $usr['usr_name'] .": ". "vom " . date($date_format,$in) ." bis " . date($date_format,$out);
	$header=array('Datum','von','bis','h\'m','Kunde','Projekt','Tätigkeit');
} else {
	$title = $usr['usr_name'] .": ". "from " . date($date_format,$in) ." to " . date($date_format,$out);
	$header=array('Date','in','out','h\'m','Customer','Project','Event');
}




// ================
// = generate PDF =
// ================
$pdf=new kimaiprint("L");

$pdf->SetFont('Arial', '', 10);

$pdf->AddPage();
$pdf->zefTable();

if (!$filterID || !$customerhack) { // FPKF
    
    $pdf->AddPage();
    $pdf->subTable();

} // FPKF

$pdf->Output("kimai.pdf","I");
?>