<?php
/**
 * This file is part of 
 * Kimai - Time Tracking For Designers // http://www.kimai.org
 * (c) 2006/07 Torsten Hoeltge
 * 
 * Kimai is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; Version 2 of June 1991.
 * 
 * Kimai is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Kimai; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * @global string  $link database connection
 *
 *
 * from config include:
 * @global string $server_hostname
 * @global string $server_database
 * @global string $server_username
 * @global string $server_password
 * @global string $server_prefix
 * @global string $language de, en, nl ....
 *  
 * @global array   $lang localization
 * @global string  $skin                                                          
 * @global integer $now                                                       
 *
 */

// =============================
// = Smarty (initialize class) =
// =============================
require_once('../includes/smarty/Smarty.class.php');
$tpl = new Smarty();
$tpl->template_dir = '../templates/';
$tpl->compile_dir  = '../includes/smarty/templates_c';
$tpl->cache_dir    = '../includes/smarty/cache';
$tpl->config_dir   = '../includes/smarty/configs';
     
// ==================================
// = implementing standard includes =
// ==================================
include('../includes/basics.php');
require_once( "../language/${language}.php" );

// ============================================================================================
// = assigning language and config variables / they are needed in all following smarty output =
// ============================================================================================
$usr  = checkUser(); 
$conf = get_config($usr['usr_ID']);
$tpl->assign('conf', $conf);

// ovveride conf.php language if user has a chosen language in the prefs
if ($conf['lang'] != "") {
    $language = $conf['lang'];
}
require_once( "../language/${language}.php" );
$tpl->assign('lang',$lang);

$comment_types   = array($lang['ctype0'],$lang['ctype1'],$lang['ctype2']);

// ==================
// = security check =
// ==================
if ( isset($_REQUEST['ax']) && !is_array($_REQUEST['ax']) && $_REQUEST['ax']!="") {
    $ax = strip_tags($_REQUEST['ax']);
}

// ==============================
// = write send timespace to DB =
// ==============================
if ($ax == "set_timespace") {
    $timespace_in  = explode('-',$_REQUEST['timespace_in']);
    $timespace_in  = (int)mktime(0,0,0,$timespace_in[0],$timespace_in[1],$timespace_in[2]);
    $timespace_out = explode('-', $_REQUEST['timespace_out']);
    $timespace_out = (int)mktime(23,59,59,$timespace_out[0],$timespace_out[1],$timespace_out[2]);
    $time_err = save_timespace($timespace_in,$timespace_out,$usr['usr_ID']);

    // both correct
    if (!$time_err['out'] && !$time_err['in']) {
        echo "0";
    }
    
    // out wrong
    if ($time_err['out'] && !$time_err['in']) {
        echo "1";
    }

    // in wrong
    if (!$time_err['out'] && $time_err['in']) {
        echo "2";
    }

    // both wrong
    if ($time_err['out'] && $time_err['in']) {
        echo "3";
    }
}

// ============================================
// = initialize currently displayed timespace =
// ============================================
// $in  = (int)mktime(0,0,0,$fromMonth,$fromDay,$fromYear);
// $out = (int)mktime(23,59,59,$toMonth,$toDay,$toYear);
$timespace = get_timespace($usr['usr_ID']);
$in = $timespace[0];
$out = $timespace[1];

//$current_timer = get_current_timer($usr['usr_ID']);
/* gesamtzeiten errechnen - wird aber eigentlich nicht mehr gebraucht an der stelle */
//$zef_time_day   = get_zef_time_day($inPoint,$usr['usr_ID']);
//$zef_time_year  = get_zef_time_year($currentYear,$usr['usr_ID']);
//$zef_time_all = get_zef_time_all($usr['usr_ID']); // nicht loeschen



// ==================
// = handle request =
// ==================
switch ($ax) {

    // ==============================================
    // = Load time sheet data from DB and return it =
    // ==============================================
    case 'zef':
    	$arr_zef = get_arr_zef($usr['usr_ID'],$in,$out,1);
    	if (count($arr_zef)>0) {
    	    $tpl->assign('arr_zef', $arr_zef);
    	} else {
    	    $tpl->assign('arr_zef', 0);
    	}
    	SetRecordConfig($arr_zef,$usr['usr_ID']);
        $tpl->assign('total', intervallApos(get_zef_time($usr['usr_ID'],$in,$out)));
        echo $tpl->fetch("core/zef.tpl");
        
    break;

    // ============================================================================================
    // = load customer table from DB - returned table includes time summary for current timespace =
    // ============================================================================================
    case 'knd':
        $arr_knd = get_arr_knd_with_time($usr['usr_grp'],$usr['usr_ID'],$in,$out);
        if (count($arr_knd)>0) {
            $tpl->assign('arr_knd', $arr_knd);
    	} else {
    	    $tpl->assign('arr_knd', 0);
    	}
    	$tpl->assign('filter', $conf['filter']);
    	$tpl->assign('customerhack', $customerhack);
        echo $tpl->fetch("core/knd.tpl");
    break;

    // ===========================================================================================
    // = load project table from DB - returned table includes time summary for current timespace =
    // ===========================================================================================
    case 'pct':
        $arr_pct = get_arr_pct_with_time($usr['usr_grp'],$usr['usr_ID'],$in,$out);
        if (count($arr_pct)>0) {
            $tpl->assign('arr_pct', $arr_pct);
    	} else {
    	    $tpl->assign('arr_pct', 0);
    	}
        echo $tpl->fetch("core/pct.tpl");
    break;

    // ==========================================================================================
    // = load events table from DB - returned table includes time summary for current timespace =
    // ==========================================================================================
    case 'evt':
        $arr_evt = get_arr_evt_with_time($usr['usr_grp'],$usr['usr_ID'],$in,$out);
        if (count($arr_evt)>0) {
            $tpl->assign('arr_evt', $arr_evt);
    	} else {
    	    $tpl->assign('arr_evt', 0);
    	}
        echo $tpl->fetch("core/evt.tpl");
    break;

    // ===================================================================
    // = displays the selectors and the bumper in the upper right corner =
    // = In this case the bumper is the red stop button                  =
    // ===================================================================
    case 'showStop':
        $tpl->assign('watchtext', 0);
        echo $tpl->fetch("core/stop.tpl");
    break;

    // ====================================
    // = Displays the selectors           =
    // = Bumper is the green start button =
    // ====================================
    case 'showRecord':

// select for projects
      $sel = makeSelectBox("pct",$usr['usr_grp']);
      $tpl->assign('sel_pct_names', $sel[0]);
      $tpl->assign('sel_pct_IDs',   $sel[1]);
// select for events
      $sel = makeSelectBox("evt",$usr['usr_grp']);
      $tpl->assign('sel_evt_names', $sel[0]);
      $tpl->assign('sel_evt_IDs',   $sel[1]);
// preselected
        $tpl->assign('lastProject', $conf['lastProject']);
        $tpl->assign('lastEvent',   $conf['lastEvent']);

        echo $tpl->fetch("core/record.tpl");
    break;

    // ============================================================================================
    // = Display dialogue for adding new customers, projects or events and process according data =
    // ============================================================================================
    case 'add':

        if (isset($_REQUEST['subject']) && !is_array($_REQUEST['subject']) && $_REQUEST['subject']!="") {
            $subject = addslashes($_REQUEST['subject']);
            switch ($subject) {
                case 'knd': 
                case 'evt': 
                    echo $tpl->fetch("core/add_${subject}.tpl"); 
                break;
                case 'pct': 
                
                    // select for customers
                        $sel = makeSelectBox("knd",$usr['usr_grp']);
                        $tpl->assign('sel_knd_names', $sel[0]);
                        $tpl->assign('sel_knd_IDs',   $sel[1]);
                    //

                    echo $tpl->fetch("core/add_pct.tpl");
                break;
                default: exit;
            }
        }

        if (isset($_REQUEST['pct']) && !is_array($_REQUEST['pct']) && $_REQUEST['pct']!="" && isset($_REQUEST['knd_ID']) && !is_array($_REQUEST['knd_ID']) && $_REQUEST['knd_ID']!="") {
            $pct_name = strip_tags($_REQUEST['pct']);
            $knd_ID = strip_tags($_REQUEST['knd_ID']);
            @mysql_query("INSERT INTO ${server_prefix}pct (pct_name,pct_kndID,pct_grpID) VALUES ('$pct_name','$knd_ID','".$usr['usr_grp']."');");
        }
        if (isset($_REQUEST['knd']) && !is_array($_REQUEST['knd']) && $_REQUEST['knd']!="") {
            $knd_name = urldecode(strip_tags($_REQUEST['knd']));
            @mysql_query("INSERT INTO ${server_prefix}knd (knd_name,knd_grpID) VALUES ('$knd_name','".$usr['usr_grp']."');");
        }
        if (isset($_REQUEST['evt']) && !is_array($_REQUEST['evt']) && $_REQUEST['evt']!="") {
            $evt_name = urldecode(strip_tags($_REQUEST['evt']));
            @mysql_query("INSERT INTO ${server_prefix}evt (evt_name,evt_grpID) VALUES ('$evt_name','".$usr['usr_grp']."');");
        }

    break;

    // =========================================================================================
    // = Display dialogue for editing customers, projects or events and process according data =
    // =========================================================================================
    case 'edit':
        if (isset($_REQUEST['subject']) && !is_array($_REQUEST['subject'])) $subject = $_REQUEST['subject'];
        if (isset($_REQUEST['id'])      && !is_array($_REQUEST['id']))      $id = $_REQUEST['id'];
        if (isset($_REQUEST['value'])   && !is_array($_REQUEST['value']))   $name = $_REQUEST['value'];
        if (isset($_REQUEST['knd_ID'])  && !is_array($_REQUEST['knd_ID']))  $knd_ID = $_REQUEST['knd_ID'];

        if (isset($_REQUEST['edit']) && $_REQUEST['edit'] == 1) {
            EditItem($subject,$name,$id,$knd_ID);
            echo "done";
            exit;
        }
        
        if (isset($_REQUEST['erase']) && $_REQUEST['erase'] == 1) {
            EraseItem($subject,$id);
            echo "done";
            exit;
        }
    
        if (!isset($_REQUEST['edit']) && !isset($_REQUEST['erase'])) {
            $name = GetItemName($subject,$id);
            $tpl->assign('id', $id);
            $tpl->assign('name', $name);
            $tpl->assign('knd_ID', $knd_ID);        
            $tpl->assign('used', getUsage($id,$subject));
        
            switch ($subject) {
                case 'knd':
                    $display = $tpl->fetch("core/edit_knd.tpl"); 
                    echo $display;
                break;
                case 'pct':

                    // select for customers
                        $sel = makeSelectBox("knd",$usr['usr_grp']);
                        $tpl->assign('sel_knd_names', $sel[0]);
                        $tpl->assign('sel_knd_IDs',   $sel[1]);
                    //

                    $tpl->assign('selected', $knd_ID);
                    echo $tpl->fetch("core/edit_pct.tpl");
                break;
                case 'evt':
                    $display = $tpl->fetch("core/edit_evt.tpl"); 
                    echo $display;
                break;
                default: exit;
            }
        }
    break;

    // ==================================================
    // = display dialogue for edit a timesheet record   =
    // ==================================================
    case 'editRecord':
        if (isset($_REQUEST['id']) && !is_array($_REQUEST['id']) && $_REQUEST['id']!="") $id = (int)($_REQUEST['id']);
        $zef_entry = get_entry_zef($id);
        $recordingstate   = $zef_entry['zef_out'];
        $tpl->assign('id', $id);
        $tpl->assign('comment', $zef_entry['zef_comment']);
        
        $tpl->assign('edit_in', date("d.m.Y",$zef_entry['zef_in']));
        $tpl->assign('edit_out', date("d.m.Y",$zef_entry['zef_out']));
        
        $tpl->assign('edit_in_time',  date("H:i:s",$zef_entry['zef_in']));
        $tpl->assign('edit_out_time', date("H:i:s",$zef_entry['zef_out']));

		// select for projects
		$sel = makeSelectBox("pct",$usr['usr_grp']);
		$tpl->assign('sel_pct_names', $sel[0]);
		$tpl->assign('sel_pct_IDs',   $sel[1]);
		// select for events
		$sel = makeSelectBox("evt",$usr['usr_grp']);
		$tpl->assign('sel_evt_names', $sel[0]);
		$tpl->assign('sel_evt_IDs',   $sel[1]);
		// preselected
        $tpl->assign('Project', $zef_entry['pct_ID']);
        $tpl->assign('Event',   $zef_entry['evt_ID']);
        
        $tpl->assign('comment_types', $comment_types);
        $tpl->assign('comment_values', array('0','1','2'));
        $tpl->assign('comment_active', $zef_entry['zef_comment_type']);

        echo $tpl->fetch("core/edit_record.tpl");
    break;

    // ===========================================================
    // = display dialogue to add a record to the main time table =
    // ===========================================================
    case 'addRecord':
        
		// select for projects
		$sel = makeSelectBox("pct",$usr['usr_grp']);
		$tpl->assign('sel_pct_names', $sel[0]);
		$tpl->assign('sel_pct_IDs',   $sel[1]);
		// select for events
		$sel = makeSelectBox("evt",$usr['usr_grp']);
		$tpl->assign('sel_evt_names', $sel[0]);
		$tpl->assign('sel_evt_IDs',   $sel[1]);
        
        $tpl->assign('comment_types', $comment_types);
        $tpl->assign('comment_values', array('0','1','2'));

        echo $tpl->fetch("core/add_record.tpl");
    break;

    // =====================================================
    // = process posted values of the edit record dialogue =
    // =====================================================
    case 'writeRecord':
    
        if (isset($_REQUEST['add'])) {
            $addflag = 1;
        } else {
            $addflag = 0;
        }
    
        // splitting up the in and out values
        $setTimeValue = 1;
        
        $id             = strip_tags($_REQUEST['id']);
        $pct_ID         = strip_tags($_REQUEST['pct']);
        $evt_ID         = strip_tags($_REQUEST['evt']);
        $comment        = strip_tags($_REQUEST['comment']);
        $comment_type   = strip_tags($_REQUEST['comment_type']);
        
        $edit_in        = str_replace(" ","",strip_tags($_REQUEST['edit_in']));
        $edit_out       = str_replace(" ","",strip_tags($_REQUEST['edit_out']));
        $edit_in_time   = str_replace(" ","",strip_tags($_REQUEST['edit_in_time']));
        $edit_out_time  = str_replace(" ","",strip_tags($_REQUEST['edit_out_time']));
        
        $edit_in        = expand_date_shortcut($edit_in);
        $edit_out       = expand_date_shortcut($edit_out);
        $edit_in_time   = expand_time_shortcut($edit_in_time);
        $edit_out_time  = expand_time_shortcut($edit_out_time);
        
        $new_in  = "${edit_in}-${edit_in_time}";
        $new_out = "${edit_out}-${edit_out_time}";
        
        if (!ereg("([0-9]{1,2})\.([0-9]{1,2})\.([0-9]{2,4})-([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})",$new_in))  $setTimeValue = 0;
        if (!ereg("([0-9]{1,2})\.([0-9]{1,2})\.([0-9]{2,4})-([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})",$new_out)) $setTimeValue = 0;

        $explode_in  = explode("-",$new_in);
        $explode_out = explode("-",$new_out);

        $date_in  = explode(".",$explode_in[0]);
        $date_out = explode(".",$explode_out[0]);

        $time_in  = explode(":",$explode_in[1]);
        $time_out = explode(":",$explode_out[1]);

        $new_in  = mktime($time_in[0], $time_in[1], $time_in[2], $date_in[1], $date_in[0], $date_in[2]);
        $new_out = mktime($time_out[0],$time_out[1],$time_out[2],$date_out[1],$date_out[0],$date_out[2]); 

        $new_time = (int)$new_out - (int)$new_in;
        if ($new_time < 1) {
            $setTimeValue = 0;
        }

        // soll der eintrag direkt geloescht werden?
        if ($_REQUEST['erase'] == "true") {
            $query = "DELETE FROM ${server_prefix}zef WHERE zef_ID = $id LIMIT 1;";
        // wenn er nicht geloescht werden soll -> update oder neu anlegen
        } else {

            if ($setTimeValue) {
            
            $records = explode_record($new_in,$new_out);
            
            $in   = $records[0]['in'];
            $out  = $records[0]['out'];
            $diff = $records[0]['diff'];
            
                // wenn der eintrag neu hinzugefuegt werden soll -> INSERT
                    if ($addflag == 1) {
                        $usr_ID = $usr['usr_ID'];
                        $query =
                        "INSERT INTO ${server_prefix}zef
                        (`zef_pctID`,`zef_evtID`,`zef_comment`,`zef_comment_type`,`zef_in`,`zef_out`,`zef_time`,`zef_usrID`)
                VALUES  ('$pct_ID','$evt_ID','$comment','$comment_type','$in','$out','$diff','$usr_ID');";

                // wenn der eintrag gerade laeuft und nur fertig gestellt werden muss -> UPDATE
                    } else {
                        $query = "UPDATE ${server_prefix}zef SET 
                                  zef_pctID =   '$pct_ID', 
                                  zef_evtID =   '$evt_ID', 
                                  zef_comment = '$comment',
                                  zef_comment_type = '$comment_type',
                                  zef_in =      '$in',
                                  zef_out =     '$out',
                                  zef_time =    '$diff'
                        WHERE zef_ID = $id;";
                    }
                    
                    if (count($records)>1) {
                        $last_task['zef_pctID'] = $pct_ID;
                        $last_task['zef_evtID'] = $evt_ID;
                        save_further_records($usr['usr_ID'],$last_task,$records);
                    }
                    
            } else {

                 // eintrag updaten der keine korrekte zeitangabe hat
                 $query = "UPDATE ${server_prefix}zef SET
                           zef_pctID =   '$pct_ID',
                           zef_evtID =   '$evt_ID',
                           zef_comment = '$comment',
                           zef_comment_type = '$comment_type'
                 WHERE zef_ID = $id;";
            }
            
        }
        @mysql_query($query);
        //echo"<script type='text/javascript'>alert('klkjlkjlj');</script>";
    break;

	// ========================================
	// = Erase timesheet etry via quickdelete =
	// ========================================
    case 'quickdelete':
        $id = $_REQUEST['id'];
        mysql_query("DELETE FROM `${server_prefix}zef` WHERE `zef_ID` = '$id';");
    break;

    // ========================
    // = start bumper pressed =
    // ========================
    case 'record':
        if ((!$conf['recordingstate']) && ($conf['lastRecord'])) {
            stopRecorder($usr['usr_ID']);
        }
    	$evt_ID = $_REQUEST['evt'];
    	$pct_ID = $_REQUEST['pct'];
    	StartRecorder($pct_ID,$evt_ID,$usr['usr_ID']);
    break;

    // =======================
    // = stop bumper pressed =
    // =======================
    case 'stop':
        stopRecorder($usr['usr_ID']);
    break;

    // ====================================
    // = displays preferences dialogue... =
    // ====================================
    case 'Prefs':
        $tpl->assign('skins', ls("../skins"));
        $tpl->assign('langs', langs());
        $tpl->assign('conf', $conf);
        $display = $tpl->fetch("misc/preferences.tpl");
        echo $display;
    break;

	// ========================================
	// = ...and writes changes back to the DB =
	// ========================================
    case 'editPrefs':
    
        if (isset($_REQUEST['skin']) && $_REQUEST['skin']!="") {
            mysql_query(sprintf("UPDATE `${server_prefix}conf` SET `skin` = '%s' WHERE `conf_usrID` = '%d';",$_REQUEST['skin'],$usr['usr_ID']));
        }

        if (isset($_REQUEST['autoselection']) && ($_REQUEST['autoselection']=="1" || $_REQUEST['autoselection']=="0")) {
                mysql_query(sprintf("UPDATE `${server_prefix}conf` SET `autoselection` = '%d' WHERE `conf_usrID` = '%d';",$_REQUEST['autoselection'],$usr['usr_ID']));
        }

        if (isset($_REQUEST['quickdelete']) && ($_REQUEST['quickdelete']=="1" || $_REQUEST['quickdelete']=="0")) {
                mysql_query(sprintf("UPDATE `${server_prefix}conf` SET `quickdelete` = '%d' WHERE `conf_usrID` = '%d';",$_REQUEST['quickdelete'],$usr['usr_ID']));
        }

        if (isset($_REQUEST['rowlimit']) && ($_REQUEST['rowlimit']>0)) {
                mysql_query(sprintf("UPDATE `${server_prefix}conf` SET `rowlimit` = '%d' WHERE `conf_usrID` = '%d';",$_REQUEST['rowlimit'],$usr['usr_ID']));
        }
        
        if (isset($_REQUEST['lang'])) {
                mysql_query(sprintf("UPDATE `${server_prefix}conf` SET `lang` = '%s' WHERE `conf_usrID` = '%d';",$_REQUEST['lang'],$usr['usr_ID']));
        }

        if (isset($_REQUEST['password']) && $_REQUEST['password']!="") {
            $passCrypt = crypt($_REQUEST['password'],$cryptmethod);
            mysql_query(sprintf("UPDATE `${server_prefix}usr` SET `pw` = '$passCrypt' WHERE `usr_ID` = '%d';",$usr['usr_ID']));
        }
        
    break;

    // ====================
    // = displays credits =
    // ====================
    case 'Credits':
        $tpl->assign('about', $lang['about']);
        $tpl->assign('version', $version);
        $display = $tpl->fetch("misc/credits.tpl");
        echo $display;
    break;

    // =====================================================
    // = returns projects selectorboxes next to the bumper =
    // =====================================================
    case 'selPct':
    // select for projects
      $sel = makeSelectBox("pct",$usr['usr_grp']);
      $tpl->assign('sel_pct_names', $sel[0]);
      $tpl->assign('sel_pct_IDs',   $sel[1]);
      $tpl->assign('Project', $conf['lastProject']);

      $display = $tpl->fetch("core/select_pct.tpl");
      echo $display;
    break;

    // =============================================
    // = returns event selector next to the bumper =
    // =============================================
    case 'selEvt':
    // select for events
      $sel = makeSelectBox("evt",$usr['usr_grp']);
      $tpl->assign('sel_evt_names', $sel[0]);
      $tpl->assign('sel_evt_IDs',   $sel[1]);
      $tpl->assign('Event', $conf['lastEvent']);

      $display = $tpl->fetch("core/select_evt.tpl");
      echo $display;
    break;

    // =============================
    // = Temporary Customer Filter =
    // =============================
    case 'filter':
    mysql_query(sprintf("UPDATE `${server_prefix}conf` SET `filter` = '%d' WHERE `conf_usrID` = '%d';",$_REQUEST['id'],$usr['usr_ID']));
    // this is connected to a hidden feature and can be activated in the file vars.php inside the includes dir
    break;


// -----------------------------------------------------------------------------------------------------------------------------
// ADMIN GOES FROM HERE

    case 'admin':
    
    // only admins can call this up...
    if ($usr['usr_sts']!=0) {
        exit;
    }
        
        // create new user account
        if (isset($_REQUEST['newuser']) && $_REQUEST['newuser']!="") {
            $randomUsrID = random_number(9);
            mysql_query("INSERT INTO `${server_prefix}conf` (`conf_usrID`, `rowlimit`, `skin`) VALUES ($randomUsrID, 100, 'standard');");
            mysql_query(sprintf("INSERT INTO `${server_prefix}usr` (`usr_ID`,`usr_name`,`pw`,`usr_active`) VALUES ('$randomUsrID','%s','',0);",$_REQUEST['newuser']));
            echo $randomUsrID;
            exit;
        }
        
        // create new group
        if (isset($_REQUEST['newgroup']) && $_REQUEST['newgroup']!="") {
            $query=sprintf("INSERT INTO `${server_prefix}grp` (`grp_name`) VALUES ('%s');",$_REQUEST['newgroup']);
            $err=mysql_query($query);
            #logfile("$err:$query",".."); // for debugging purposes only ...
        }

        // update values in the global preferences
        if (isset($_REQUEST['tab']) && $_REQUEST['tab']=="advanced") {
            mysql_query(sprintf("UPDATE `${server_prefix}var` SET `value` = '%s' WHERE `var` = 'adminmail';",$_REQUEST['adminmail']));
            mysql_query(sprintf("UPDATE `${server_prefix}var` SET `value` = '%d' WHERE `var` = 'loginTries';",$_REQUEST['logintries']));
            mysql_query(sprintf("UPDATE `${server_prefix}var` SET `value` = '%d' WHERE `var` = 'loginBanTime';",$_REQUEST['loginbantime']));
            mysql_query(sprintf("UPDATE `${server_prefix}var` SET `value` = '%s' WHERE `var` = 'charset';",$_REQUEST['charset']));
            $conf = get_config($usr['usr_ID']);
            $tpl->assign('updated', true);
        }

        // ==============
        // = Build Tabs =
        // ==============
        // admin user
        if (!isset($_REQUEST['tab']) || $_REQUEST['tab'] == "users" || $_REQUEST['tab'] == "groups" || $_REQUEST['tab'] == "advanced" && !isset($_REQUEST['action'])) {

            $tpl->assign('conf', $conf);
            $tpl->assign('curr_user', $usr['usr_name']);
            $tpl->assign('arr_grp',  get_arr_grp());
            $tpl->assign('arr_usr',  get_arr_usr());
            $tpl->assign('database', $server_database);

            $admin['users'] = $tpl->fetch("admin/users.tpl");
            $admin['groups'] = $tpl->fetch("admin/groups.tpl");
            
            $tpl->assign('charsets', $charsets);
            $tpl->assign('charset_descr', $charset_descr);
 
            $admin['advanced'] = $tpl->fetch("admin/advanced.tpl");
        }

        // =======================
        // = Builds Database Tab =
        // =======================
        if (!isset($_REQUEST['tab'])) {
            $tpl->assign('conf', $conf);
            $admin['database'] = $tpl->fetch("admin/database.tpl"); 
        }

        // =============================
        // = Builds edit-user dialogue =
        // =============================
        if (isset($_REQUEST['tab']) && isset($_REQUEST['action']) && $_REQUEST['action']=="editUsr") {
            $usr_details = get_usr($_REQUEST['id']);
            
            $arr = get_arr_grp();
            
            $i=0;
            foreach ($arr as $row) {
                $arr_grp_name[$i] = $row['grp_name'];
                $arr_grp_ID[$i]   = $row['grp_ID'];
                $i++;
            }
            
            $tpl->assign('arr_grp_ID',   $arr_grp_ID);
            $tpl->assign('arr_grp_name', $arr_grp_name);
                        
            $tpl->assign('usr_details', $usr_details);
            $admin['users'] = $tpl->fetch("admin/edituser.tpl"); 
        }

        // =============================
        // = Builds edit-group dialogue =
        // =============================
        if (isset($_REQUEST['tab']) && isset($_REQUEST['action']) && $_REQUEST['action']=="editGrp") {
            
            $arr = get_arr_usr();
            
            $i=0;
            foreach ($arr as $row) {
                $arr_usr_name[$i] = $row['usr_name'];
                $arr_usr_ID[$i]   = $row['usr_ID'];
                $i++;
            }
            
            $tpl->assign('arr_usr_ID',   $arr_usr_ID);
            $tpl->assign('arr_usr_name', $arr_usr_name);
            
            $grp_details = get_grp($_REQUEST['id']);
            $tpl->assign('grp_details', $grp_details);
            $admin['groups'] = $tpl->fetch("admin/editgroup.tpl"); 
        }

        // ====================================================================
        // = Builds the entire Admin window using the recently generated tabs =
        // ====================================================================
        if (!isset($_REQUEST['tab'])) {
            $tpl->assign('admin', $admin);
            echo $tpl->fetch("admin/main.tpl");
        } else {
            echo $admin[$_REQUEST['tab']];
        }
                
    break;
    


    // ====================================================
    // = process values send via ajax from the dmin panel =
    // ====================================================

    case "ajax_admin":
    
    // only admins can call this up...
    if ($usr['usr_sts']!=0) {
        exit;
    }
        
        // Ban a user from login
        if (isset($_REQUEST['ban'])) {
            mysql_query(sprintf("UPDATE `${server_prefix}usr` SET `usr_active` = '0' WHERE `usr_ID` = '%d';",$_REQUEST['ban']));
            echo "<img border=0 title='".$lang['bannedusr']."' alt='".$lang['bannedusr']."' src='../skins/".$conf['skin']."/grfx/lock.gif' width=16 height=16 />";
        }
        
        // Unban a user from login
        if (isset($_REQUEST['unban'])) {
            mysql_query(sprintf("UPDATE `${server_prefix}usr` SET `usr_active` = 1 WHERE `usr_ID` = '%d';",$_REQUEST['unban']));
            echo "<img border=0 title='".$lang['activeusr']."' alt='".$lang['activeusr']."' src='../skins/".$conf['skin']."/grfx/jipp.gif' width=16 height=16 />";
        }
        
        // Fire JavaScript confirm when a user is about to be deleted
        if (isset($_REQUEST['del'])) {
            echo "Sicher?";
        }
        
        // If the confirmation is returned the user gets a trash-flag. 
        // TODO: Users with trashflag can be deleated by 'empty trashcan' or so ...
        if (isset($_REQUEST['delete_usr'])) {
            mysql_query(sprintf("UPDATE `${server_prefix}usr` SET `usr_trash` = '1' WHERE `usr_ID` = '%d';",$_REQUEST['delete_usr']));
        }
        if (isset($_REQUEST['delete_grp'])) {
            mysql_query(sprintf("UPDATE `${server_prefix}grp` SET `grp_trash` = '1' WHERE `grp_ID` = '%d';",$_REQUEST['delete_grp']));
        }
        
        // this updates a user record ...
        if (isset($_REQUEST['update_usr'])) {
            mysql_query(sprintf("UPDATE `${server_prefix}usr` SET `usr_name` = '%s', `usr_grp` = '%d', `usr_sts` = '%d', `usr_mail` = '%s'
            WHERE `usr_ID` = '%d';",$_REQUEST['usr_name'],$_REQUEST['usr_grp'],$_REQUEST['usr_sts'],$_REQUEST['usr_mail'],$_REQUEST['update_usr']));
            
            // ... and if nessesary it also updates the password for that user
            if (isset($_REQUEST['usr_pw']) && $_REQUEST['usr_pw'] != '') {
	            $passCrypt = crypt($_REQUEST['usr_pw'],$cryptmethod);
                mysql_query(sprintf("UPDATE `${server_prefix}usr` SET `pw` = '%s' WHERE `usr_ID` = '%d';",$passCrypt,$_REQUEST['update_usr']));
            }
        }
        
        // process data from editgroup template (send in via jQuery)
        // if the given group_leader ID for that group equals the ID of an admin-user the user-status must not be changed ->
        // is only changed when the leader-user was normal user before
        if (isset($_REQUEST['update_grp'])) {
            mysql_query(sprintf("UPDATE `${server_prefix}grp` SET `grp_name` = '%s', `grp_leader` = '%d'
            WHERE `grp_ID` = '%d';",$_REQUEST['grp_name'],$_REQUEST['grp_leader'],$_REQUEST['update_grp']));
            
            // set status of new leader to 1 (1=leaduser)
            mysql_query(sprintf("UPDATE `${server_prefix}usr` SET `usr_sts` = '1' WHERE `usr_ID` = '%d' AND `usr_sts` = '2';",$_REQUEST['grp_leader']));
        }

    break;

}

?>
