<?php
/**
 * This file is part of 
 * Kimai - Time Tracking For Designers // http://www.kimai.org
 * (c) 2006/07 Torsten Hoeltge
 * 
 * Kimai is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; Version 2 of June 1991.
 * 
 * Kimai is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Kimai; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

// ---------------------------------------------------------------------------------------
/**
 * checks if user is logged on and returns user information as array
 * kicks client if is not verified
 * TODO: this and get_config should be one function
 *
 * <pre>
 * returns: 
 * [usr_ID] user ID, 
 * [usr_sts] user status (rights), 
 * [usr_grp] group of user, 
 * [usr_name] username 
 * </pre>
 *
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return array
 * @author th 
 */
function checkUser() {
    global $server_prefix, $virtual_users;
    if (!$virtual_users) {
        
        if (isset($_COOKIE['kimai_usr']) && isset($_COOKIE['kimai_key']) && $_COOKIE['kimai_usr'] != "0" && $_COOKIE['kimai_key'] != "0") {
            $kimai_usr = addslashes($_COOKIE['kimai_usr']);
            $kimai_key = addslashes($_COOKIE['kimai_key']);
            if (get_seq($kimai_usr) != $kimai_key) {
                kickUser();
            } else {
                $data     = mysql_query(sprintf("SELECT usr_ID,usr_sts,usr_grp FROM ${server_prefix}usr WHERE usr_name = '%s' AND usr_active = '1' AND NOT usr_trash = '1';",$kimai_usr));
                $row      = @mysql_fetch_assoc($data);
                $usr_ID   = $row['usr_ID'];
                $usr_sts  = $row['usr_sts']; // User Status -> 0=Admin | 1=GroupLeader | 2=User
                $usr_grp  = $row['usr_grp'];
                $usr_name = $kimai_usr;
                if ($usr_ID < 1) {
                    kickUser();
                }
            }
            
        } else {
            kickUser();
        }

    } else {
        $usr_ID   = $_SESSION['user']; 
        $usr_grp  = $_SESSION['user'];  
        $usr_name = $_SESSION['user'];  
        $usr_sts  = 2; 
    }
    
    if ($usr_ID<1) {
        kickUser();
    }
    
    $usr = array("usr_ID"=>$usr_ID,"usr_sts"=>$usr_sts,"usr_grp"=>$usr_grp,"usr_name"=>$usr_name);
    return $usr;
}

function kickUser() {
    die("<script type='text/javascript'>window.location.href = '../index.php?a=logout';</script>");
}
// ---------------------------------------------------------------------------------------
/**
 * get global configuration AND details from a specific user
 *
 * returns array as follows:
 * <pre>
 * [conf_usrID] user ID
 * [rowlimit] number of lines displayed in the timesheet
 * [skin] => skin name (name of directory)
 * [recordingstate] => 127
 * [lastProject] => pct ID
 * [lastEvent] => evt ID
 * [zef_anzahl] => count of records
 * [timespace_in] => *timestamp*  ... first this was stored in cookies but that didn't work very well - cookies forget ...DB keeps entries forever
 * [timespace_out] => *timestamp*
 * [autoselection] => 1/0
 * [quickdelete] => 1/0
 * [version] => current DATABASE version
 * [login] => 1/0
 * [kimail] => email address
 * [lang] => language can be configured for all users individually
 * [adminmail] => email address
 * [loginTries] => how many times wrong login is possible before ...
 * [loginBanTime] => ... user gets banned for xxx seconds
 * [lastdbbackup] => timestamp - time of last global backup (not user-specific backup!)
 * [filter_knd] = comma separated list of customers to sum in the timeview
 * [filter_pct] = comma separated list of projects to sum in the timeview
 * [filter_evt] = comma separated list of events to sum in the timeview
 * [view_knd] = comma separated list of customers to show in the subtable
 * [view_pct] = comma separated list of projects to show in the subtable and the pulldown 
 * [view_evt] = comma separated list of events to show in the subtable and the pulldown
 * [filter] => temporary field for filtering only for one customer in the pdf printout (hidden feature)
 * [charset] => global charset which appears in the html header (also used for printout)
 * </pre>
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return array
 * @author th
 *
 */
function get_config($user) {
    global $server_prefix;    
    $data   = @mysql_query("SELECT * FROM ${server_prefix}conf WHERE conf_usrID = '$user';");
    $c1     = @mysql_fetch_assoc($data);
    $data   = @mysql_query("SELECT * FROM ${server_prefix}var;");
    $row    = @mysql_fetch_assoc($data);
    if (is_array($row)) {
        do { $c2[$row['var']]=$row['value']; } 
        while ($row = mysql_fetch_assoc($data));
        if (is_array($c1) && is_array($c2)) $conf = array_merge ($c1,$c2);
        else $conf   = $c2;
        mysql_free_result($data);  
        return $conf;
    }
}


// ---------------------------------------------------------------------------------------

/**
 * returns formatted time string -> h:mm
 * input: number of seconds 
 *
 * @param integer $sek seconds to extract the time from
 * @return string
 * @author th
 */
function intervallApos($sek) {
    return sprintf('%d:%02d', $sek / 3600, $sek / 60 % 60);
}

// ---------------------------------------------------------------------------------------
/**
 * returns formatted time string -> h:mm:ss
 * input: number of seconds 
 *
 * @param integer $sek seconds to extract the time from
 * @return string
 * @author th
 */
function intervallColon($sek) {
    return sprintf('%d:%02d:%02d', $sek / 3600, $sek / 60 % 60, $sek % 60);
}

// ---------------------------------------------------------------------------------------
/**
 * returns hours, minutes and seconds as array
 * input: number of seconds
 *
 * @param integer $sek seconds to extract the time from
 * @return array
 * @author th
 */
function hourminsec($sek) {  
    $i['h']   = $sek / 3600 % 24;
    $i['i']   = $sek / 60 % 60; 
    $i['s']   = $sek % 60;
    return $i;
}

// ---------------------------------------------------------------------------------------
/**
 * returns ID of running timesheet event for specific user
 *
 * <pre>
 * ['zef_ID'] ID of last recorded task
 * ['zef_in'] in point of timesheet record in unix seconds
 * ['zef_pctID']
 * ['zef_evtID']
 * </pre>
 *
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return integer
 * @author th
 */
function get_event_last ($user) {
    global $server_prefix, $conf;
    
    $lastRecord = $conf['lastRecord'];
       
    $data = @mysql_query("SELECT zef_ID,zef_in,zef_pctID,zef_evtID FROM ${server_prefix}zef WHERE zef_ID = '$lastRecord';");
    $row  = mysql_fetch_assoc($data);
    mysql_free_result($data);
    
    return $row;
}

// ---------------------------------------------------------------------------------------
/**
 * returns array of subdirectorys - needed for skin selector
 *
 * @param string $dir Directory to list subdirectorys from
 * @return array
 * @author unknown
 */
function ls($dir){
    $arr_subfolders = array();
    $i=0;
	$handle = opendir($dir);
		while (false !== ($readdir = readdir($handle))) {
			if ($readdir != '.' && $readdir != '..' && substr($readdir,0,1) != '.'  && is_dir("${dir}/${readdir}") ) {
				$arr_subfolders[$i] = $readdir;
				$i++;
			}
		}
	return isset($arr_subfolders)?$arr_subfolders:false;
	closedir($handle);
}

// ---------------------------------------------------------------------------------------
/**
 * returns array of language files
 *
 * @param none
 * @return array
 * @author unknown/th
 */
function langs(){
    $arr_files = array();
    $arr_files[0] = "";
    $i=1;
	$handle = opendir('../language/');
		while (false !== ($readdir = readdir($handle))) {
			if ($readdir != '.' && $readdir != '..' && substr($readdir,0,1) != '.'  && $readdir != ("index.php") ) {
                $readdir = str_replace(".php", "", $readdir);
				$arr_files[$i] = $readdir;
				$i++;
			}
		}
	return isset($arr_files)?$arr_files:false;
	closedir($handle);
}

// ---------------------------------------------------------------------------------------
/**
 * returns array for smarty's html_options funtion
 *
 * <pre>
 * returns:
 * [0] -> pct/evt names
 * [1] -> values as IDs
 * </pre>
 *
 * @param string either 'pct' or 'evt'
 * @return array
 * @author th
 */
function makeSelectBox($subject,$user){

    switch ($subject) {
        case('pct'):
            $arr_pct = get_arr_pct($user);
            for ($i=0; $i< count($arr_pct); $i++) {
                $sel[0][$i] = $arr_pct[$i]['pct_name'] . " (" . $arr_pct[$i]['knd_name'] . ")";
                $sel[1][$i] = $arr_pct[$i]['pct_ID'];
            }
        break;
        case('evt'):
            $arr_evt = get_arr_evt($user);
            for ($i=0; $i< count($arr_evt); $i++) {
                $sel[0][$i] = $arr_evt[$i]['evt_name'];
                $sel[1][$i] = $arr_evt[$i]['evt_ID'];
            }
        break;
        case('knd'):
            $arr_knd = get_arr_knd($user);
            for ($i=0; $i< count($arr_knd); $i++) {
                $sel[0][$i] = $arr_knd[$i]['knd_name'];
                $sel[1][$i] = $arr_knd[$i]['knd_ID'];
            }
        break;

      }

      return $sel;
}

// ---------------------------------------------------------------------------------------
/**
 * returns single timesheet entry as array
 *
 * @param integer $id ID of entry in table zef
 * @global string $server_prefix prefix for database tables 
 * @return array
 * @author th
 */
function get_entry_zef($id) {
    global $server_prefix;     
    $query =
    "SELECT * FROM `${server_prefix}zef` 
    Left Join `${server_prefix}pct` ON `${server_prefix}zef`.`zef_pctID` = `${server_prefix}pct`.`pct_ID` 
    Left Join `${server_prefix}knd` ON `${server_prefix}pct`.`pct_kndID` = `${server_prefix}knd`.`knd_ID` 
    Left Join `${server_prefix}grp` ON `${server_prefix}grp`.`grp_ID`    = `${server_prefix}pct`.`pct_grpID` 
    Left Join `${server_prefix}evt` ON `${server_prefix}evt`.`evt_ID`    = `${server_prefix}zef`.`zef_evtID`
    WHERE zef_ID = $id
    LIMIT 1;";
    $data   = mysql_query($query);
    $anzahl = mysql_num_rows($data);
    $row    = mysql_fetch_assoc($data);
    mysql_free_result($data);
    return $row;
}

// ---------------------------------------------------------------------------------------
/**
 * returns timesheet for specific user as multidimensional array
 *
 * @param integer $user ID of user in table usr
 * @param integer $in start of timespace in unix seconds
 * @param integer $out end of timespace in unix seconds
 * @global string $server_prefix prefix for database tables
 * @global array $conf global configuration  
 * @return array
 * @author th 
 */
function get_arr_zef($user,$in,$out,$limit) {
    global $server_prefix,$conf;
    $currTimespace = "AND zef_in > $in AND zef_out < $out";
    if ($limit) {
        $limit = "LIMIT " .$conf['rowlimit'];
    } else {
        $limit="";
    }
    $query = "SELECT zef_ID, zef_in, zef_out, zef_time, zef_pctID, zef_evtID, zef_usrID, pct_ID, knd_name, grp_name, pct_grpID, pct_kndID, evt_name, pct_name, zef_comment, zef_comment_type
             FROM ${server_prefix}zef 
             Left Join ${server_prefix}pct ON zef_pctID = pct_ID        Left Join ${server_prefix}knd ON pct_kndID = knd_ID
             Left Join ${server_prefix}grp ON grp_ID    = pct_grpID     Left Join ${server_prefix}evt ON evt_ID    = zef_evtID
             WHERE zef_pctID > 0 AND zef_evtID > 0 AND zef_usrID = '$user'
             $currTimespace 
             ORDER BY zef_in DESC $limit;";
    $data   = @mysql_query($query);
    $i=0;
    $arr=array();
    /* TODO: needs revision as foreach loop */
    while ($row = mysql_fetch_assoc($data)) {
        $arr[$i]['zef_ID']      = $row['zef_ID'];
        $arr[$i]['zef_in']      = $row['zef_in'];
        $arr[$i]['zef_out']     = $row['zef_out'];
        $arr[$i]['zef_time']    = $row['zef_time'];
        $arr[$i]['zef_apos']    = intervallApos($row['zef_time']);
        $arr[$i]['zef_coln']    = intervallColon($row['zef_time']);
        $arr[$i]['zef_pctID']   = $row['zef_pctID'];
        $arr[$i]['zef_evtID']   = $row['zef_evtID'];
        $arr[$i]['zef_usrID']   = $row['zef_usrID'];
        $arr[$i]['pct_ID']      = $row['pct_ID'];
        $arr[$i]['knd_name']    = $row['knd_name'];
        $arr[$i]['grp_name']    = $row['grp_name'];
        $arr[$i]['pct_grpID']   = $row['pct_grpID'];
        $arr[$i]['pct_kndID']   = $row['pct_kndID'];
        $arr[$i]['evt_name']    = $row['evt_name'];
        $arr[$i]['pct_name']    = $row['pct_name'];
        $arr[$i]['zef_comment'] = $row['zef_comment'];
        $arr[$i]['zef_comment_type'] = $row['zef_comment_type'];
        $i++;
    }
    mysql_free_result($data);
    return $arr;
}         

// ---------------------------------------------------------------------------------------
/**
 * returns time summary of current timesheet
 *
 * @param integer $user ID of user in table usr
 * @param integer $in start of timespace in unix seconds
 * @param integer $out end of timespace in unix seconds
 * @global string $server_prefix prefix for database tables
 * @global array $conf global configuration  
 * @return integer
 * @author th 
 */
function get_zef_time($user,$in,$out) {
    global $server_prefix,$conf;
    $currTimespace = "AND zef_in > $in AND zef_out < $out";
    $limit = $conf['rowlimit'];
    $data = @mysql_query("SELECT SUM(zef_time) AS zeit FROM ${server_prefix}zef WHERE zef_usrID = '$user' $currTimespace LIMIT $limit;");
    $data = mysql_fetch_assoc($data);
    $zeit = $data['zeit'];
    return $zeit;
}         

// ---------------------------------------------------------------------------------------
/**
 * returns list of customers in a group as array
 *
 * @param integer $group ID of group in table grp
 * @global string $server_prefix prefix for database tables 
 * @return array
 * @author th
 */
function get_arr_knd($group) {
    global $server_prefix;    
    $arr = array();
    $data  = mysql_query("SELECT * FROM ${server_prefix}knd WHERE knd_grpID = '$group' ORDER BY knd_name;");
    $i=0;
    while ($row = mysql_fetch_assoc($data)) {
        $arr[$i]['knd_ID']  = $row['knd_ID'];
        $arr[$i]['knd_name'] = $row['knd_name'];
        $i++;
    }
    mysql_free_result($data);
    return $arr;
}

// ---------------------------------------------------------------------------------------
/**
 * returns list of time summary attached to customer ID's within specific timespace as array
 * !! becomes obsolete with new querys !!
 *
 * @param integer $user ID of user in table usr
 * @param integer $in start of timespace in unix seconds
 * @param integer $out end of timespace in unix seconds
 * @global string $server_prefix prefix for database tables 
 * @return array
 * @author th
 */
function get_arr_time_knd($user,$in,$out) {
    global $server_prefix;
    if ($in) $zeitraum="AND zef_in > $in";
    if ($in && $out) $zeitraum="AND zef_in > $in AND zef_in < $out";
    $arr = array();  
    $query="SELECT SUM(zef_time) as zeit, knd_ID FROM ${server_prefix}zef 
            Left Join ${server_prefix}pct ON zef_pctID = pct_ID
            Left Join ${server_prefix}knd ON pct_kndID = knd_ID 
            WHERE zef_usrID = '$user' $zeitraum GROUP BY knd_ID;";
    $data  = mysql_query($query);
    while ($row = mysql_fetch_assoc($data)) {
        $arr[$row['knd_ID']] = $row['zeit'];
    }
    mysql_free_result($data);
    return $arr;
}

// ---------------------------------------------------------------------------------------
/**
 * returns list of customers and their time summary within specific timespace as array
 *
 * revised version with join query
 *
 * 25.05.07 - rausgeschmissen weil:
 * zeiten werden für die gruppe, und nicht für den user addiert
 *
 * @param integer $group ID of group in table grp
 * @param integer $user ID of user in table usr
 * @param integer $in start time in unix seconds
 * @param integer $out end time in unix seconds
 * @global string $server_prefix prefix for database tables 
 * @return array
 * @author th
 */
 /* 
function get_arr_knd_with_time($group,$user,$in,$out) {
    global $server_prefix;    
    $arr = array();
    
    if ($in) $timespace="WHERE zef_in > $in";
    if ($in && $out) $timespace.=" AND zef_in < $out";

    $query="SELECT ${server_prefix}knd.knd_name, ${server_prefix}knd.knd_ID, zef_view.zeit
            FROM
            ${server_prefix}knd
            
            Left Join (
                        select sum(${server_prefix}zef.zef_time) AS zeit,
                        ${server_prefix}pct.pct_kndID AS pct_kndID 
                        FROM (${server_prefix}zef
                        join ${server_prefix}pct on (${server_prefix}pct.pct_ID = ${server_prefix}zef.zef_pctID)
                        
            )
             
            $timespace
            group by ${server_prefix}pct.pct_kndID) as zef_view ON zef_view.pct_kndID = ${server_prefix}knd.knd_ID 
            WHERE ${server_prefix}knd.knd_grpID = '$group'
            ORDER BY ${server_prefix}knd.knd_name;";
            
    $data = mysql_query($query);
    $i=0;
    while ($row = mysql_fetch_assoc($data)) {
        $arr[$i]['knd_ID']   = $row['knd_ID'];
        $arr[$i]['knd_name'] = $row['knd_name'];
        $arr[$i]['zeit']     = intervallApos($row['zeit']);
        $i++;
    }
    mysql_free_result($data);
    return $arr;
}
*/

// ---------------------------------------------------------------------------------------
/**
 * returns list of projects for specific group as array
 *
 * @param integer $user ID of user in database
 * @global string $server_prefix prefix for database tables 
 * @return array
 * @author th
 */
function get_arr_pct($group) {
    global $server_prefix;    
    $arr = array();
    $query="SELECT * FROM ${server_prefix}pct,${server_prefix}knd WHERE pct_kndID = knd_ID AND pct_grpID = '$group' ORDER BY pct_name;";
    $data = mysql_query($query);
    //echo $query;
    $i=0;
    while ($row = mysql_fetch_assoc($data)) {
        $arr[$i]['pct_ID']   = $row['pct_ID'];
        $arr[$i]['pct_name'] = $row['pct_name'];
        $arr[$i]['knd_name'] = $row['knd_name'];
        $arr[$i]['knd_ID']   = $row['knd_ID'];
        $i++;
    }
    mysql_free_result($data);
    return $arr;
}

// ---------------------------------------------------------------------------------------
/**
 * returns list of time summary attached to project ID's within specific timespace as array
 * !! becomes obsolete with new querys !!
 *
 * @param integer $user ID of user in table usr
 * @param integer $in start time in unix seconds
 * @param integer $out end time in unix seconds
 * @global string $server_prefix prefix for database tables 
 * @return array
 * @author th
 */
function get_arr_time_pct($user,$in,$out) {
    global $server_prefix;
    if ($in) $zeitraum="AND zef_in > $in";
    if ($in && $out) $zeitraum="AND zef_in > $in AND zef_in < $out";
    $arr = array();
    $query = "SELECT sum(zef_time) as zeit,zef_pctID FROM ${server_prefix}zef WHERE zef_usrID = '$user' $zeitraum GROUP BY zef_pctID;";
    //echo $query;
    $data  = mysql_query($query);
    while ($row = mysql_fetch_assoc($data)) {
        $arr[$row['zef_pctID']] = $row['zeit'];
    }
    mysql_free_result($data);
    return $arr;
}

// ---------------------------------------------------------------------------------------
/**
 * returns list of projects and their time summary within zef_entry timespace as array
 *
 * OLD VERSION THAT MERGES TWO QUERYS - bad bad stuff ... 
 * TODO: [tom] revise with join query!
 *
 * @param integer $group ID of group in table grp
 * @param integer $user ID of user in table usr
 * @param integer $in start time in unix seconds
 * @param integer $out end time in unix seconds
 * @global string $server_prefix prefix for database tables 
 * @return array
 * @author th
 */
function get_arr_pct_with_time($group,$user,$in,$out) {
    global $server_prefix; 
    
    $arr_pcts = get_arr_pct($group);
    $arr_time = get_arr_time_pct($user,$in,$out);
    
    $arr = array(); 
    
    $i=0;
    foreach ($arr_pcts as $pct) {
        $arr[$i]['pct_ID']   = $pct['pct_ID'];
        $arr[$i]['knd_ID']   = $pct['knd_ID'];
        $arr[$i]['pct_name'] = $pct['pct_name'];
        $arr[$i]['knd_name'] = $pct['knd_name'];
        $arr[$i]['zeit']     = @intervallApos($arr_time[$pct['pct_ID']]);
        $i++;
    }
    
    return $arr;
}



#
# #
# #
# #
# #
# #




# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

## In Array laden: Events |
function get_arr_evt($group) {
    global $server_prefix;
    $arr = array();
    $data  = mysql_query("SELECT * FROM ${server_prefix}evt WHERE evt_grpID = '$group' ORDER BY evt_name;");
    $i=0;
    while ($row = mysql_fetch_assoc($data)) {
        $arr[$i]['evt_ID'] = $row['evt_ID'];
        $arr[$i]['evt_name'] = $row['evt_name'];
        $i++;
    }
    mysql_free_result($data);
    return $arr;
}

## Gesamtzeiten errechnen: Events  |
function get_arr_time_evt($user,$in,$out) {
    global $server_prefix;
    if ($in) $zeitraum="AND zef_in > $in";
    if ($in && $out) $zeitraum="AND zef_in > $in AND zef_in < $out";
    $arr = array();    
    $data  = mysql_query("SELECT sum(zef_time) as zeit,zef_evtID FROM ${server_prefix}zef WHERE zef_usrID = '$user' $zeitraum GROUP BY zef_evtID;");
    while ($row = mysql_fetch_assoc($data)) {
        $arr[$row['zef_evtID']] = $row['zeit'];
    }
    mysql_free_result($data);
    return $arr;
}

## ALTE VERSION !!!
## In Array laden: Events mit zeiten |
function get_arr_evt_with_time($group,$user,$in,$out) {
    global $server_prefix; 
    
    $arr_evts = get_arr_evt($group);
    $arr_time = get_arr_time_evt($user,$in,$out);
    
    $arr = array(); 
    
    $i=0;
    foreach ($arr_evts as $evt) {
        $arr[$i]['evt_ID']   = $evt['evt_ID'];
        $arr[$i]['evt_name'] = $evt['evt_name'];
        if (isset($arr_time[$evt['evt_ID']])) $arr[$i]['zeit'] = intervallApos($arr_time[$evt['evt_ID']]);
        else $arr[$i]['zeit'] = intervallApos(0);
        $i++;
    }
    
    return $arr;
}


## ALTE VERSION !!!
## In Array laden: Kunden mit zeiten |
function get_arr_knd_with_time($group,$user,$in,$out) {
    global $server_prefix; 
    
    $arr_knds = get_arr_knd($group);
    $arr_time = get_arr_time_knd($user,$in,$out);
    
    $arr = array(); 
    
    $i=0;
    foreach ($arr_knds as $knd) {
        $arr[$i]['knd_ID']   = $knd['knd_ID'];
        $arr[$i]['knd_name'] = $knd['knd_name'];
        if (isset($arr_time[$knd['knd_ID']])) $arr[$i]['zeit'] = intervallApos($arr_time[$knd['knd_ID']]);
        else $arr[$i]['zeit'] = intervallApos(0);
        $i++;
    }
    
    return $arr;
}



# NEUE VERSION !!!! --- QUERY STIMMT NOCH NICHT

/*
## In Array laden: EVENTS MIT ZEITEN |
function get_arr_evt_with_time($group,$user,$in,$out) {
    global $server_prefix;    
    $arr = array();
    
    if ($in) $zeitraum="WHERE zef.zef_in > $in";
    if ($in && $out) $zeitraum.=" AND zef.zef_in < $out";
            
    $query="SELECT   
               Sum(${server_prefix}zef.zef_time) AS zeit,   
               ${server_prefix}evt.evt_name,  
               ${server_prefix}evt.evt_ID  
               FROM   
               ${server_prefix}zef   
               INNER JOIN ${server_prefix}evt ON ${server_prefix}zef.zef_evtID = ${server_prefix}evt.evt_ID  
               $zeitraum  
               AND evt.evt_grpID = '$group'  
               GROUP by zef_evtID  
               ";
            
    $data = mysql_query($query);
    //echo $query;
    $i=0;
    while ($row = mysql_fetch_assoc($data)) {
        $arr[$i]['evt_ID']   = $row['evt_ID'];
        $arr[$i]['evt_name'] = $row['evt_name'];
        $arr[$i]['zeit']     = intervallApos($row['zeit']);
        $i++;
    }
    mysql_free_result($data);
    return $arr;
}

// SELECT 
// Sum(${server_prefix}zef.zef_time) AS Zeit, 
// ${server_prefix}evt.evt_name 
// FROM 
// ${server_prefix}zef 
// INNER JOIN ${server_prefix}evt ON ${server_prefix}zef.zef_evtID = ${server_prefix}evt.evt_ID 
// GROUP by zef_evtID

*/
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#
# #
# #
# #
# #
# #




// ---------------------------------------------------------------------------------------
/**
 * returns time of currently running event recording as array
 *
 * result is meant as params for the stopwatch if the window is reloaded
 *
 * <pre>
 * returns:
 * [all] start time of entry in unix seconds (forgot why I named it this way, sorry ...)
 * [hour]
 * [min]
 * [sec]
 * </pre>
 *
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return array
 * @author th
 */
function get_current_timer($user) {
    global $server_prefix;    
    $data      = mysql_query("SELECT zef_ID,zef_in,zef_time FROM ${server_prefix}zef WHERE zef_usrID = '$user' ORDER BY zef_in DESC LIMIT 1;");
    $row       = mysql_fetch_assoc($data);
    $zef_time  = (int)$row['zef_time'];
    $zef_in    = (int)$row['zef_in'];
    mysql_free_result($data);

    if (!$zef_time && $zef_in) {
        $aktuelleMessung = hourminsec(time()-$zef_in);
        $current_timer['all']  = $zef_in;
        $current_timer['hour'] = $aktuelleMessung['h'];
        $current_timer['min']  = $aktuelleMessung['i'];
        $current_timer['sec']  = $aktuelleMessung['s'];
    } else {
        $current_timer['hour'] = 0;
        $current_timer['min']  = 0;
        $current_timer['sec']  = 0;
    }
    return $current_timer;
}

// ---------------------------------------------------------------------------------------
/**
 * returns the total worktime of a zef_entry day
 *
 * WARNING: $inPoint has to be *exactly* the first second of the day 
 *
 * @param integer $inPoint begin of the day in unix seconds
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return string
 * @author th 
 */
function get_zef_time_day($inPoint,$user) {
    global $server_prefix;    
    $outPoint=$inPoint+86399;
    $query = "SELECT sum(zef_time) as zeit FROM ${server_prefix}zef WHERE zef_in > $inPoint AND zef_out < $outPoint AND zef_usrID = '$user';";
    $data  = mysql_query($query) or die(mysql_error());
    $row   = mysql_fetch_assoc($data);
    mysql_free_result($data);
    return $row['zeit'];
}

// ---------------------------------------------------------------------------------------
/**
 * returns the total worktime of a zef_entry month
 *
 * WARNING: $inPoint has to be *exactly* the first second of any day in the desired month 
 *
 * @param integer $inPoint begin of one day of desired month in unix seconds
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return string
 * @author th 
 */
function get_zef_time_mon($inPoint,$user) {
    global $server_prefix; 
    
    $inDatum_m = date("m",$inPoint);
    $inDatum_Y = date("Y",$inPoint);
    $inDatum_t = date("t",$inPoint);
    
    $inPoint  = mktime(0,0,0,$inDatum_m,1,$inDatum_Y);
    $outPoint = mktime(23,59,59,$inDatum_m,$inDatum_t,$inDatum_Y);

    $query = "SELECT sum(zef_time) as zeit FROM ${server_prefix}zef WHERE zef_in > $inPoint AND zef_out < $outPoint AND zef_usrID = '$user';";
    $data  = mysql_query($query) or die(mysql_error());
    $row   = mysql_fetch_assoc($data);
    mysql_free_result($data);
    return $row['zeit'];
}

// ---------------------------------------------------------------------------------------
/**
 * returns the total worktime in database
 *
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return string
 * @author th 
 */
function get_zef_time_all($user) {
    global $server_prefix;    
    $query = "SELECT sum(zef_time) as zeit FROM ${server_prefix}zef WHERE zef_usrID = '$user'";
    $data  = mysql_query($query) or die(mysql_error());
    $row   = mysql_fetch_assoc($data);
    mysql_free_result($data);
    return $row['zeit'];
}

// ---------------------------------------------------------------------------------------
/**
 * returns the total worktime of a zef_entry year
 *
 * @param integer $year 4 digit year (not sure it 2 digits work...)
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return string
 * @author th 
 */
function get_zef_time_year($year,$user) {
    global $server_prefix;    
    $in  = (int)mktime(0,0,0,1,1,$year); 
    $out = (int)mktime(23,59,59,12,(int)date("t"),$year);
    $query = "SELECT sum(zef_time) as zeit FROM ${server_prefix}zef WHERE zef_in > $in AND zef_out < $out AND zef_usrID = '$user'";
    $data  = mysql_query($query) or die(mysql_error());
    $row   = mysql_fetch_assoc($data);
    mysql_free_result($data);
    return $row['zeit'];
}

// ---------------------------------------------------------------------------------------
/**
 * returns true if an event is on record
 *
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return string
 * @author th 
 */
function get_recordingstate($user) {
    global $server_prefix;    
    $data     = @mysql_query("SELECT zef_out FROM ${server_prefix}zef WHERE zef_usrID = '$user' ORDER BY zef_in DESC LIMIT 1;");
    $row      = @mysql_fetch_assoc($data);
    $state   = $row['zef_out'];
    mysql_free_result($data);
    if ($state == "0" || !$data) return true; 
    else return false; 
}

// ---------------------------------------------------------------------------------------
/**
 * returns a random code with given length
 *
 * @global integer $length length of the code
 * @return array
 * @author th
 */
function random_code($length) { 
    $code = ""; 
    $string="ABCDEFGHIJKLMNPQRSTUVWXYZabcdefghijklmnpqrstuvwxyz0123456789";
    mt_srand((double)microtime()*1000000); 
    for ($i=1; $i <= $length; $i++) { 
        $code .= substr($string, mt_rand(0,strlen($string)-1), 1); 
    } 
    return $code; 
} 

// ---------------------------------------------------------------------------------------
/**
 * returns a random number with X digits
 *
 * @global integer $length digit count of number
 * @return array
 * @author th
 */
function random_number($length) { 
    $number = ""; 
    $string="0123456789";
    mt_srand((double)microtime()*1000000); 
    for ($i=1; $i <= $length; $i++) { 
        $number .= substr($string, mt_rand(0,strlen($string)-1), 1); 
    } 
    return $number; 
} 

// ---------------------------------------------------------------------------------------
/**
 * checks if the database structure needs to be updated for new Kimai version. 
 * if yes the function redirects to /admin/updater.php
 *
 * @param string $path path to admin dir relative to the document that calls this function (usually "." or "..")
 * @global string $version version of Kimai software
 * @return array
 * @author th
 */
function checkDBversion($path) {
    global $version;
    $installedVersion = get_DBversion();
    $installedVersion = "$installedVersion";
    if ($installedVersion != $version) {
        header("Location: $path/updater.php");
        exit;
    }
}

// ---------------------------------------------------------------------------------------
/**
 * returns the version of the installed Kimai database (not of the software)
 *
 * @param string $path path to admin dir relative to the document that calls this function (usually "." or "..")
 * @global string $version version of Kimai software
 * @return array
 * @author th
 */
function get_DBversion() {
    global $server_prefix;
    $query       = "SELECT value FROM ${server_prefix}var WHERE var = 'version';";
    $data        = @mysql_query($query);
    $row         = @mysql_fetch_assoc($data);
    $versionDB   = $row['value'];
    if (!is_array($row)) $versionDB = "0.5.1";
    if (is_array($row)) mysql_free_result($data);
    return $versionDB;
}


// ---------------------------------------------------------------------------------------
/**
 * returns the key for the session of a specific user 
 *
 * the key is both stored in the database (usr table) and a cookie on the client. 
 * when the keys match the user is allowed to access the Kimai GUI. 
 * match test is performed via function userCheck()
 *
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return string
 * @author th 
 */
function get_seq($user) {
    global $server_prefix;
    $query       = "SELECT secure FROM ${server_prefix}usr WHERE usr_name = '$user';";
    $data        = @mysql_query($query);
    $row         = @mysql_fetch_assoc($data);
    $seq         = $row['secure'];
    mysql_free_result($data);
    return $seq;
}

// ---------------------------------------------------------------------------------------
/**
 * returns array of all users 
 *
 * [usr_ID] => 23103741
 * [usr_name] => admin
 * [usr_grp] => 1
 * [usr_sts] => 0
 * [grp_name] => miesepriem
 * [usr_mail] => 0
 * [usr_active] => 0
 *
 *
 * @global string $server_prefix prefix for database tables
 * @return array
 * @author th 
 */
function get_arr_usr() {
    global $server_prefix;    
    $arr = array();
    $data  = mysql_query("SELECT * FROM ${server_prefix}usr Left Join ${server_prefix}grp ON usr_grp = grp_ID WHERE usr_trash !=1 ORDER BY usr_name;");
    $i=0;
    while ($row = mysql_fetch_assoc($data)) {
        $arr[$i]['usr_ID']   = $row['usr_ID'];
        $arr[$i]['usr_name'] = $row['usr_name'];
        $arr[$i]['usr_grp']  = $row['usr_grp'];
        $arr[$i]['usr_sts']  = $row['usr_sts'];
        $arr[$i]['grp_name'] = $row['grp_name'];
        $arr[$i]['usr_mail'] = $row['usr_mail'];
        $arr[$i]['usr_active'] = $row['usr_active'];
        if ($row['pw']!=''&&$row['pw']!='0') {
            $arr[$i]['usr_pw'] = "yes"; 
        } else {                 
            $arr[$i]['usr_pw'] = "no"; 
        }
        $i++;
    }
    mysql_free_result($data);
    return $arr;
}


// ---------------------------------------------------------------------------------------
/**
 * returns array of all groups 
 *
 *
 *
 * @global string $server_prefix prefix for database tables
 * @return array
 * @author th 
 *
 * TODO: [tom] Dirty Mergequery .... make new version with ONE query
 */
function get_arr_grp() {
    global $server_prefix; 
    
    $data = @mysql_query("SELECT * FROM ${server_prefix}grp WHERE grp_trash !=1 ORDER BY grp_name;");
  
    // merge the number of users in that group into the query
    $groups = array();
    $i=0;
    while ($row = mysql_fetch_assoc($data)){
    	$groups[] = $row; 
    	$count = @mysql_query("SELECT COUNT(*) AS anz_usr FROM ${server_prefix}usr WHERE usr_grp='$row[grp_ID]' AND usr_trash='0';");
    	
    	$count_users = mysql_fetch_assoc($count);
    	$count_users = $count_users['anz_usr'];
    	$groups[$i]['count_users'] = $count_users;
    	$i++;
    }

    // merge name of the leader user into the query
    $i=0;
    foreach ($groups as $thisgroup) {
        $query="SELECT usr_name FROM ${server_prefix}usr WHERE usr_ID='" .$thisgroup['grp_leader']. "'";
    	$leader_name = @mysql_query($query);
    	$leader_name = mysql_fetch_assoc($leader_name);
    	$leader_name = $leader_name['usr_name'];
    	$groups[$i]['leader_name'] = $leader_name;
    	$i++;
    }
   
    return $groups;
}



// ---------------------------------------------------------------------------------------
/**
 * performed when the stop bumper is hit.
 * Checks what record is currently recording and
 * writes the end time into that entry.
 * if the measured timevalue is longer than one calendar day
 * it is split up and stored in the DB by days
 *
 * @global string $server_prefix prefix for database tables
 * @global integer $now
 * @param integer $user ID of user
 * @author th 
 *
 */
## stop running recording |
function stopRecorder($user) {
    global $server_prefix,$now;
    
    $last_task = get_event_last($user);      // aktuelle vorgangs-ID auslesen
    
    $zef_ID = $last_task['zef_ID'];
    $zef_in = $last_task['zef_in'];

    // ...in-zeitpunkt und jetzt-zeitpunkt werden an den EXPLODER gesendet
    // der daraus ein mehrdimensionales array macht. die tage dieses arrays
    // werden anschließend in die DB zurückgeschreiben
    $records = explode_record($zef_in,$now);

    $difference = $records[0]['diff'];

    // hier wird sofort mal der erste ausgeworfene tag verarbeitet.
    // wenn nur einer zurückgekommen ist, ist die verarbeitung danach direkt
    // beendet.
    // update zeitdifferenz in laufendem vorgang speichern
    mysql_query("UPDATE ${server_prefix}zef SET zef_time = $difference WHERE zef_ID = '$zef_ID';");

    // update outPoint in laufendem vorgang speichern
    mysql_query(sprintf("UPDATE ${server_prefix}zef SET zef_out = %d WHERE zef_ID = '$zef_ID';",$records[0]['out']));

    // noch mehr tage?
    if (count($records)>1) {
        save_further_records($user,$last_task,$records);
    }
        
}


function save_further_records($user,$last_task,$records) {
    global $lang, $server_prefix;


	// $debug =  $records[1]['in'] . " - " . $records[1]['out'] . " - " . $records[1]['diff'];
	//     logfile($debug,".."); // for debugging purposes only ...

    // nur der zweite eintrag wird zusätzlich gespeichert
    // TODO: schleife für alle einträge

    $pctID = $last_task['zef_pctID'];
    $evtID = $last_task['zef_evtID'];


	// $debug = "pctID: $pctID";
	//     logfile($debug,".."); // for debugging purposes only ...
	// $debug = "evtID: $evtID";
	//     logfile($debug,".."); // for debugging purposes only ...
   
    if (count($records)>2) {
        $type = 2;
        $comment=$lang['ac_error']; // auto continued with error (entry too long).";
    } else {
        $type = 1;
        $comment=$lang['ac']; // "auto continued.";
    }

       $debug = mysql_query(
            sprintf(
                "INSERT INTO ${server_prefix}zef

                 (`zef_in`, `zef_out`, `zef_time`,
                  `zef_usrID`,`zef_pctID`,`zef_evtID`,`zef_comment`,`zef_comment_type`)

                  VALUES

                 ('%d','%d','%d',
                 '$user', '$pctID', '$evtID','$comment','$type');",

                $records[1]['in'], $records[1]['out'], $records[1]['diff']
            )
        );

}


// ---------------------------------------------------------------------------------------
/**
 * starts timesheet record
 *
 * @param integer $pct_ID ID of project to record
 * @global string $server_prefix prefix for database tables 
 * @author th
 */
function StartRecorder($pct_ID,$evt_ID,$user) {
    global $conf, $server_prefix, $now;
    ## neuen vorgang anlegen |
    $query    = "SELECT pct_kndID FROM ${server_prefix}pct WHERE pct_ID = '$pct_ID';";
    $data     = @mysql_query($query);
    $row      = @mysql_fetch_assoc($data);
    $knd_ID   = $row['pct_kndID'];
    @mysql_free_result($data);
    
    @mysql_query("INSERT INTO ${server_prefix}zef (zef_pctID,zef_evtID,zef_in,zef_usrID) VALUES ('$pct_ID','$evt_ID','$now','$user');");
    @mysql_query("UPDATE ${server_prefix}conf SET lastRecord = LAST_INSERT_ID() WHERE conf_usrID = '$user';");
}

// ---------------------------------------------------------------------------------------
/**
 * erases entry in either knd, pct or evt
 *
 * @param string $subject (either knd, pct or evt)
 * @param integer $id ID of item
 * @global string $server_prefix prefix for database tables 
 * @author th
 */
function EraseItem($subject,$id) {
    global $server_prefix;
    $query = "DELETE FROM ${server_prefix}$subject WHERE ${subject}_ID = $id LIMIT 1;";
    @mysql_query($query);
}        
      
// ---------------------------------------------------------------------------------------
/**
 * updates name of an item (entry in knd, pct or evt)
 *
 * @param string $subject (either knd, pct or evt)
 * @param string $name (new name of item)
 * @param integer $id ID of item
 * @param integer $knd_ID ID of attached customer (in case of project)
 * @global string $server_prefix prefix for database tables 
 * @author th
 */  
function EditItem($subject,$name,$id,$knd_ID=0) {
    //$name = utf8_encode($name);
    global $server_prefix;
        if ($subject!="pct") $query = "UPDATE ${server_prefix}$subject SET ${subject}_name = '$name' WHERE ${subject}_ID = $id;";
        else $query = "UPDATE ${server_prefix}$subject SET ${subject}_name = '$name', ${subject}_kndID = '$knd_ID' WHERE ${subject}_ID = $id;";
    @mysql_query($query);
}   


// ---------------------------------------------------------------------------------------
/**
 * returns name of an item (entry in knd, pct or evt)
 *
 * @param integer $id ID of item
 * @param string $subject (either knd, pct or evt)
 * @global string $server_prefix prefix for database tables 
 * @return string
 * @author th
 */      
function GetItemName($subject,$id) {
    global $server_prefix; 
    $data      = mysql_query("SELECT * FROM ${server_prefix}${subject} WHERE ${subject}_ID = '$id';");
    $row       = mysql_fetch_assoc($data);
    $sub_name  = "${subject}_name";
    $name      = $row[$sub_name];
    return $name;
}        

// ---------------------------------------------------------------------------------------
/**
 * updates recording params for zef_entry user
 *
 * @param array $arr_zef timesheet array 
 * @param integer $user ID of user in table usr 
 * @global string $server_prefix prefix for database tables 
 * @author th
 */
function SetRecordConfig($arr_zef,$user) {
    global $server_prefix; 
    
    if (is_array($arr_zef)&&count($arr_zef)>0) {
        $recordingstate = $arr_zef[0]['zef_out'];
        $lastProject    = $arr_zef[0]['zef_pctID'];
        $lastEvent      = $arr_zef[0]['zef_evtID'];
        $anzahl         = count($arr_zef);
    }
    if (!isset($recordingstate)) $recordingstate = 0;
    if (!isset($lastProject))    $lastProject    = 1;
    if (!isset($lastEvent))      $lastEvent      = 1;
    if (!isset($anzahl))         $anzahl         = 0;

    $query = "UPDATE ${server_prefix}conf SET 
        `recordingstate` = $recordingstate,
        `lastProject`    = $lastProject,
        `lastEvent`      = $lastEvent,
        `zef_anzahl`     = $anzahl
        WHERE conf_usrID = $user";
    @mysql_query($query);
}



// ---------------------------------------------------------------------------------------
/**
 * compress file via gzip - source file is left untouched
 *
 * @param string $source path of source file
 * @param ??? $level ???
 * @return string
 * @author Maximilian Kern -- wirklich? oder hatte er das nur irgendwo kopiert?
 */
function gzcompressfile($source,$level=false){
    $dest=$source.'.gz';
    $mode='wb'.$level;
    $error=false;
    if($fp_out=gzopen($dest,$mode)){
        if($fp_in=fopen($source,'rb')){
            while(!feof($fp_in))
                gzwrite($fp_out,fread($fp_in,1024*512));
                fclose($fp_in);
        }
        else $error=true;
            gzclose($fp_out);
    }
    else $error=true;
    if($error) return false;
    else return $dest;
}        

// ---------------------------------------------------------------------------------------
/**
 * returns browser name
 * 
 * returns: "Opera", "msie", "Safari", "Mozilla" or "?"
 *
 * TODO: [togi] check if this still is really needed anywhere
 * Smarty has a browser value by itself!!!
 *
 * @return string 
 * @author th
 */
function get_agent() {
    @$agent=$_SERVER["HTTP_USER_AGENT"];
    if(eregi("opera",$agent)) $browser = "Opera";
    else if(eregi("msie",$agent)) $browser = "msie";
    else if(eregi("Safari",$agent)) $browser = "Safari";
    else if(eregi("mozilla",$agent) && !eregi("Safari",$agent)) $browser = "Mozilla";
    else $browser = "?";
    return $browser;
}

// -------------------------------------------------------------------------------------------------------------------------

/**
 * return details of specific user
 *
 * <pre>
 * returns: 
 * ...
 * </pre>
 *
 * @param integer $user ID of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return array
 * @author th 
 */

function get_usr($id) {
    global $server_prefix;    
    $data  = mysql_query("SELECT * FROM ${server_prefix}usr Left Join ${server_prefix}grp ON usr_grp = grp_ID WHERE usr_ID = $id LIMIT 1;");
    $row = mysql_fetch_assoc($data);
        $arr['usr_ID']   = $row['usr_ID'];
        $arr['usr_name'] = $row['usr_name'];
        $arr['usr_grp']  = $row['usr_grp'];
        $arr['usr_sts']  = $row['usr_sts'];
        $arr['grp_name'] = $row['grp_name'];
        $arr['usr_mail'] = $row['usr_mail'];
        $arr['usr_active'] = $row['usr_active'];
        if ($row['pw']!=''&&$row['pw']!='0') {
            $arr['usr_pw'] = "yes"; 
        } else {                 
            $arr['usr_pw'] = "no"; 
        }
    mysql_free_result($data);
    return $arr;
}

// -------------------------------------------------------------------------------------------------------------------------
/**
 * return ID of specific user named 'XXX'
 *
 * @param integer $name name of user in table usr
 * @global string $server_prefix prefix for database tables
 * @return string
 * @author th
 */
function get_usr_by_name($name) {
    global $server_prefix;
    $data  = mysql_query("SELECT usr_ID FROM ${server_prefix}usr WHERE usr_name = '$name' LIMIT 1;");
    $row = mysql_fetch_assoc($data);
    mysql_free_result($data);
    return $row['usr_ID'];
}

// -------------------------------------------------------------------------------------------------------------------------
/**
 * returns data of the group with ID X
 *
 * <pre>
 * returns:
 * ['grp_ID']
 * ['grp_name']
 * ['grp_leader'] (as ID)
 * </pre>
 *
 * @param integer $id ID of group in table grp
 * @global string $server_prefix prefix for database tables
 * @return array
 * @author th
 */
function get_grp($id) {
    global $server_prefix;    
    $data  = mysql_query("SELECT * FROM ${server_prefix}grp WHERE grp_ID = $id LIMIT 1;");
    $row = mysql_fetch_assoc($data);
        $arr['grp_ID']   = $row['grp_ID'];
        $arr['grp_name'] = $row['grp_name'];
        $arr['grp_leader'] = $row['grp_leader'];
    mysql_free_result($data);
    return $arr;
}

// ---------------------------------------------------------------------------------------
/**
 * writes errors during install or update to the logfile stored in temporary
 * 
 * @param string $value (error)message
 * @param string $path relative path to temporary directory
 * @author th
 */
function logfile($value,$path="..") {
    $value = str_replace("\n", "", $value);
    $value = str_replace("  ", " ", $value);
    $value = str_replace("  ", " ", $value);
    $logdatei=fopen("$path/temporary/logfile.txt","a");
    fputs($logdatei,
        date("d.m.Y, H:i:s",time()) .
        ", " . $value ."\n"
        );
    fclose($logdatei);
}

// ---------------------------------------------------------------------------------------
/**
 * preprocess shortcut for date entries
 *
 * allowed shortcut formats are shown in the dialogue for edit timesheet entries (click the "?")
 * 
 * @param string $date shortcut date
 * @return string 
 * @author th
 */
function expand_date_shortcut($date) {
    $date  = str_replace(" ","",$date);
    $return = $date;
    
    $length = strlen($date);
    
    switch ($length) {
        case 1:
            $return = "0" . $date .".". date("m") .".". date("Y");
            
        break;        
        
        case 2:
            $return = $date .".". date("m") .".". date("Y");
        break;
        
        case 4: 
            $return = substr($date,0,2) .".". substr($date,2,2) .".". date("Y");
        break;
    
        case 6:
            $return = substr($date,0,2) .".". substr($date,2,2);
            $year=(int)substr($date,4,2);
            if ($year>70) $year = "19$year";
            else $year = "20$year";
            $return = "$return.$year";
        break;
    }
    
    if (!ereg("([0-9]{1,2})\.([0-9]{1,2})\.([0-9]{2,4})",$return))  $return = false;
    return $return;
}

// ---------------------------------------------------------------------------------------
/**
 * preprocess shortcut for time entries
 *
 * allowed shortcut formats are shown in the dialogue for edit timesheet entries (click the "?")
 * 
 * @param string $date shortcut time
 * @return string 
 * @author th
 */
function expand_time_shortcut($time) {
    $time  = str_replace(" ","",$time);
    $return = $time;
    
    $length = strlen($time);
    
    switch ($length) {
        case 1:
            $return = "0${time}:00:00";
        break;
        
        case 2:
            if ((int)$time<24) $return = "${time}:00:00";
            else $return = false;
        break;
        
        case 4:
            $hours = substr($time,0,2);
            $minutes = substr($time,2,2);
            if ((int)$hours<24 && (int)$minutes<60) $return = "${hours}:${minutes}:00";
            else $return = false;
        break;
        
        case 6:
            $hours = substr($time,0,2);
            $minutes = substr($time,2,2);
            $seconds = substr($time,4,2);
            if ((int)$hours<24 && (int)$minutes<60 && (int)$seconds<60) $return = "${hours}:${minutes}:${seconds}";
            else $return = false;
        break;
        
    }
    
    if (!ereg("([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})",$return)) $return = false;
    return $return;
}


// ---------------------------------------------------------------------------------------
/**
 * get in and out unix seconds of specific user
 *
 * <pre>
 * returns:
 * [0] -> in
 * [1] -> out
 * </pre>
 *
 * @param string $user ID of user
 * @return array
 * @author th
 */
function get_timespace($user) {
    global $server_prefix;
    $query       = "SELECT timespace_in, timespace_out FROM ${server_prefix}conf WHERE conf_usrID = '$user';";
    $data        = @mysql_query($query);
    $row         = @mysql_fetch_assoc($data);
    
    $timespace[0] = $row['timespace_in'];
    $timespace[1] = $row['timespace_out'];

    /* database has no entries? */
    $mon = date("n"); $day = date("j"); $Y = date("Y");
    if (!$timespace[0]) {
        $timespace[0] = mktime(0,0,0,$mon,1,$Y);
    }
    if (!$timespace[1]) {
        $timespace[1] = mktime(23,59,59,$mon,lastday($month=$mon,$year=$Y),$Y);
    }
    
    mysql_free_result($data);
    return $timespace;
}


// ---------------------------------------------------------------------------------------
/**
 * saves timespace of user in database (table conf)
 *
 * @param string $timespace_in unix seconds
 * @param string $timespace_out unix seconds
 * @param string $user ID of user
 *
 * @author th
 */
function save_timespace($timespace_in,$timespace_out,$user) {
    global $server_prefix;

    if ($timespace_in == 0 && $timespace_out == 0) {
        $mon = date("n"); $day = date("j"); $Y = date("Y"); 
        $timespace_in  = mktime(0,0,0,$mon,$day,$Y);
        $timespace_out = mktime(23,59,59,$mon,$day,$Y);
    }
       
    mysql_query("UPDATE `${server_prefix}conf` SET `timespace_in`  = '$timespace_in'  WHERE `conf_usrID` = '$user';");
    mysql_query("UPDATE `${server_prefix}conf` SET `timespace_out` = '$timespace_out' WHERE `conf_usrID` = '$user';");
    
    return timespace_warning($timespace_in,$timespace_out);
    
}


// ---------------------------------------------------------------------------------------
/**
 * lookup if an item (knd pct evt) is referenced in timesheet table
 * returns number of entities
 *
 * @param integer $id of item
 * @param string $subject of item
 * @return integer
 *
 * @author th
 */

function getUsage($id,$subject) {
    global $server_prefix;
    switch ($subject) {
        
        case "pct":
        case "evt":
            $query = "SELECT COUNT(*) AS result FROM ${server_prefix}zef WHERE zef_{$subject}ID = '$id';";
        break;

        case "knd":
            $query="SELECT COUNT(*) AS result FROM ${server_prefix}pct 
                    Left Join ${server_prefix}knd ON pct_kndID = knd_ID
                    WHERE pct_kndID = '$id';";
        break;
            
        default:
        break;
        
    }
        $data  = @mysql_query($query);
        $row   = @mysql_fetch_assoc($data);
        return $row['result'];
}

// ---------------------------------------------------------------------------------------
/**
 * returns last day (..30..31) of given month
 *
 * @param integer $month
 * @param integer $year
 * @return integer number of day
 *
 * @author http://lutrov.com/blog/php-last-day-of-the-month-calculation/
 */
function lastday($month = '', $year = '') {
   if (empty($month)) {
      $month = date('m');
   }
   if (empty($year)) {
      $year = date('Y');
   }
   $result = strtotime("{$year}-{$month}-01");
   $result = strtotime('-1 second', strtotime('+1 month', $result));
   return date('d', $result);
}

// ---------------------------------------------------------------------------------------
/**
 * lookup if either in or out timespace fields has to be highlighted red
 *
 * @param integer $in unix seconds
 * @param integer $out unix seconds
 * @return array
 *
 * @author th
 */

function timespace_warning($in,$out) {
    
    if ($in>time()) {
        $timespace_warning['in']=true;
    } else {
        $timespace_warning['in']=false;
    }

    if ($out<time()) {
        $timespace_warning['out']=true;
    } else {
        $timespace_warning['out']=false;
    }
    
    return $timespace_warning;
}

// ---------------------------------------------------------------------------------------
/**
 * THE DAY-EXPLODER (TM) - Makes Your Day!!
 * tries to solve the cross-midnight-problem without coffie
 *
 * hier wird gefragt ob
 * die zeitspanne von in bis out (unix seconds) nur innerhalb
 * der grenzen eines kalendertages liegt.
 * ist das nicht der fall wird der zeitraum auf mehrere tage verteilt
 * idealer output wäre ein miltidimensionales array der tage
 * mit entsprechenden in und out values
 *
 * sollte sowohl auf die direkt aufgenommenen records als auch
 * auf die editierten anwendbar sein
 *
 * <pre>
 * returns:
 * [0]['in'] -> in unix seconds of day 1
 * [0]['out']
 * [0]['diff'] -> space between in and out
 * [1]['in'] -> in unix seconds of day 2
 * [1]['out']
 * ...
 * </pre>
 *
 * @param integer $in unix seconds
 * @param integer $out unix seconds
 * @return array multi dimensional
 *
 * @author th
 */

// cross midnight bug
function explode_record($in,$out) {
    $in_date  = date("d",$in);
    $out_date = date("d",$out);
    
    $span_of_days = $out_date - $in_date;
    
    // if the recording does not cross midnight
    // then return the given values without any change - via array .
    if ($span_of_days == 0) {
        $arr[0]['in']   = $in;
        $arr[0]['out']  = $out;
        $arr[0]['diff'] = $arr[0]['out'] - $arr[0]['in'];

    // ... but if the start date differs from the end date -
    // return multiple dates via array.
    } else {
    
        // bisher geht nur ein tag ....
        // man kann also noch nicht 2 tage ununterbrochen durcharbeiten ;)
        // TODO: [tom] umschreiben (dynamisch)
        $arr[0]['in']  = $in;
        $arr[0]['out'] = mktime(23,59,59,date("n",$in),date("d",$in),date("Y",$in));
        $arr[0]['diff'] = $arr[0]['out'] - $arr[0]['in'];
        
        $arr[1]['in']  = mktime(0,0,0,date("n",$in),date("d",$in)+1,date("Y",$in));
        $arr[1]['out'] = $out;
        $arr[1]['diff'] = $arr[1]['out'] - $arr[1]['in'];
        
        if ($span_of_days > 1) {
            $arr[3] = "too much...";
        }

        
    }


    return $arr;

}

?>
