<?php
require('fpdf/fpdf.php');

class kimaiprint extends FPDF {
    
    
    //Kopfzeile
    function Header()
    {
        global $title, $total;
        //Logo
        $this->Image('../grfx/logo_print.png',10,8,33);
        //Arial fett 15
        $this->SetFont('Arial','B',15);
        //nach rechts gehen
        $this->Cell(40);

        //Titel
		if ($language == "de" && ($conf['lang'] == "de" || $conf['lang'] == "")) {
			$title_and_time = utf8_decode($title) . " - Gesamt: " . $total;
		} else {
			$title_and_time = utf8_decode($title) . " - Total: " . $total;
		}
        $this->Cell(5,15,$title_and_time,0,0,'L');
        //$this->Cell(5,15,$title,0,0,'L');


        //Zeilenumbruch
        $this->Ln(20);
    }

    //Fusszeile
    function Footer()
    {
        //Position 1,5 cm von unten
        $this->SetY(-15);
        //Arial kursiv 8
        $this->SetFont('Arial','I',8);
        //Seitenzahl
        $this->Cell(0,10,'Seite '.$this->PageNo(),0,0,'C');
    }

    //Colored table
    function zefTable()
    {
        global $zef_data,$header,$customerhack;
        
        //Colors, line width and bold font
        $this->SetFillColor(0,0,0);
        $this->SetTextColor(255);
        $this->SetDrawColor(0,0,0);
        $this->SetLineWidth(.3);
        $this->SetFont('','B');
        
        //Color and font restoration
        $this->SetFillColor(224,235,255);
        $this->SetTextColor(0);
        $this->SetFont('');
        
        //Data
        $fill=0;
        
        //Header width
        $w=array(15,15,15,15,73,73,73); // breiten der einzelnen spalten
        $maxZeilen=25;
        




////// without comments - old version ///////////

        // $seitenGes=(count($zef_data) / $maxZeilen);
        // $aktuelleZeile = 0;
        
        // for ($aktuelleSeite=1; $aktuelleSeite<$seitenGes+1; $aktuelleSeite++) {
        //     
        //     //header row
        //     $this->SetFillColor(0,0,0);
        //     $this->SetTextColor(255);
        //     $this->SetFont('','B');
        //     for($i=0;$i<count($header);$i++) {
        //         $this->Cell($w[$i],7,utf8_decode($header[$i]),1,0,'L',1);
        //     }
        //     
        //     $this->Ln();
        //     
        //     //table body
        //     $this->SetFillColor(224,235,255);
        //     $this->SetTextColor(0);
        //     $this->SetFont('');
        //     for ($tabellenzeile=0; $tabellenzeile<$maxZeilen; $tabellenzeile++) {
        //         
        //         if ($zef_data[$aktuelleZeile+$tabellenzeile][0]!='') {
        //         
        //             for ($j=0;$j<7;$j++) {
        //                 $this->Cell($w[$j],6,utf8_decode($zef_data[$aktuelleZeile+$tabellenzeile][$j]),'LR',0,'L',$fill);
        //             }
        // 
        //             $this->Ln();
        //             $fill=!$fill;
        //         }
        //         
        //     }
        //     $this->Cell(array_sum($w),0,'','T'); // tabellen schlusslinie
        //     $aktuelleZeile+=$maxZeilen;
        //     if ($aktuelleSeite<$seitenGes) {
        //         $this->AddPage();
        //     }
        // }
        
////// end without comments ///////////        
        




////// with comments ///////////

        //$seitenGes=(count($zef_data) / $maxZeilen);
        $aktuelleZeile = 0;
        $aktuelleSeitenZeile = 0;
        
        foreach ($zef_data as $timesheet_record) {
            
                    if ($aktuelleSeitenZeile==0) {
                        // print header row 
                        // on black background
                        $this->SetFillColor(0,0,0);
                        $this->SetTextColor(255);
                        $this->SetFont('','B');
                        for($i=0;$i<count($header);$i++) {
                            $this->Cell($w[$i],7,utf8_decode($header[$i]),1,0,'L',1);
                        }
                        $this->Ln(); // Linefeet
                        $aktuelleSeitenZeile++;
                    } 
 
                    //table body
                    $this->SetFillColor(224,235,255);
                    $this->SetTextColor(0);
                    $this->SetFont('');
            
                    if ($aktuelleSeitenZeile<$maxZeilen) {
                
                        // zeile schreiben
                        for ($j=0;$j<7;$j++) {
                            $this->Cell($w[$j],6,utf8_decode($zef_data[$aktuelleZeile][$j]),'LR',0,'L',$fill);
                        }
                        $this->Ln(); // Linefeet
                        $aktuelleSeitenZeile++;
                
                        // look for comment - is only printed if the customerhack is active!
                        if ($zef_data[$aktuelleZeile][7] && $customerhack ) {
                            $this->Cell(array_sum($w),6,utf8_decode($zef_data[$aktuelleZeile][7]),'LR',0,'L',$fill);
                            $this->Ln(); // Linefeet
                            $aktuelleSeitenZeile++;
                        }
                
                    } else {
                        $this->Cell(array_sum($w),0,'','T'); // tabellen schlusslinie
                        $this->AddPage();
                        $aktuelleSeitenZeile=0;
                    }

                    $fill=!$fill;           
                    $aktuelleZeile++;
                    $this->Cell(array_sum($w),0,'','T'); // tabellen schlusslinie
                    $this->Ln(); // Linefeet
            
            
        } // end foreach zefdata entry

        $this->Cell(array_sum($w),0,'','T'); // tabellen schlusslinie        
////// end with comments ///////////        
        


        
        
    } // end function zefTable()







    //Colored table
    function subTable()
    {
        global $knd_data,$pct_data,$evt_data;
        
        //Colors, line width and bold font
        $this->SetFillColor(0,0,0);
        $this->SetTextColor(255);
        $this->SetDrawColor(0,0,0);
        $this->SetLineWidth(.3);
        $this->SetFont('','B');
        
        //Color and font restoration
        $this->SetFillColor(224,235,255);
        $this->SetTextColor(0);
        $this->SetFont('');
        
        //Data
        $fill=0;
        


		if ($language == "de" && ($conf['lang'] == "de" || $conf['lang'] == "")) {
	        $knd_header= array("Kunden","Zeit");
	        $pct_header= array("Projekte","Zeit");
	        $evt_header= array("Tätigkeiten","Zeit");
		} else {
	        $knd_header= array("Customers","Time");
	        $pct_header= array("Projects","Time");
	        $evt_header= array("Events","Time");
		}
		
		        
        $knd_ende=0;
        $pct_ende=0;
        $evt_ende=0;
        
        //Header width
        $w=array(78,13);
        $abstand=3;
        $maxZeilen=25;
        
        $zeilen = count($knd_data);
        if (count($pct_data) > $zeilen) { $zeilen = count($pct_data); }
        if (count($evt_data) > $zeilen) { $zeilen = count($evt_data); }
        

        
        $seitenGes=($zeilen/$maxZeilen);
        $aktuelleZeile = 0;
        
        for ($aktuelleSeite=1; $aktuelleSeite<$seitenGes+1; $aktuelleSeite++) {
            
            //header row
            $this->SetFillColor(0,0,0);
            $this->SetTextColor(255);
            $this->SetFont('','B');
            
            // knd
            if (!$knd_ende) {
                for($i=0;$i<count($knd_header);$i++) {
                    $this->Cell($w[$i],7,utf8_decode($knd_header[$i]),1,0,'L',1);
                }
            } else {
                $this->Cell(array_sum($w),7,"");
            }
            $this->Cell($abstand,6,"",'',0,'L',0);
 
            
            // pct
            if (!$pct_ende) {
                for($i=0;$i<count($pct_header);$i++) {
                    $this->Cell($w[$i],7,utf8_decode($pct_header[$i]),1,0,'L',1);
                }
            } else {
                $this->Cell(array_sum($w),7,"");
            }
            $this->Cell($abstand,6,"",'',0,'L',0);
            
            
            // evt
            if (!$evt_ende) {
                for($i=0;$i<count($evt_header);$i++) {
                    $this->Cell($w[$i],7,utf8_decode($evt_header[$i]),1,0,'L',1);
                }
            } else {
                $this->Cell(array_sum($w),7,"");
            }
            
            $this->Ln();
            
            //table body
            $this->SetFillColor(224,235,255);
            $this->SetTextColor(0);
            $this->SetFont('');
            for ($tabellenzeile=0; $tabellenzeile<$maxZeilen; $tabellenzeile++) {
                
                //if ($knd_data[$aktuelleZeile+$tabellenzeile][0]!='') {
                
                    // knd
                    if ($knd_data[$aktuelleZeile+$tabellenzeile][0]!='') {
                        for ($j=0;$j<2;$j++) {
                            $this->Cell($w[$j],6,utf8_decode($knd_data[$aktuelleZeile+$tabellenzeile][$j]),'LR',0,'L',$fill);
                        }
                    } else {
                        if (!$knd_ende) { 
                            $this->Cell(array_sum($w),6,'','T'); 
                        } else {
                            $this->Cell(array_sum($w),6,"");
                        }
                        $knd_ende=1;
                    }
                    $this->Cell($abstand,6,"",'',0,'L',0);
                    
                    
                    // pct
                    if ($pct_data[$aktuelleZeile+$tabellenzeile][0]!='') {
                        for ($j=0;$j<2;$j++) {
                            $this->Cell($w[$j],6,utf8_decode($pct_data[$aktuelleZeile+$tabellenzeile][$j]),'LR',0,'L',$fill);
                        }
                    } else {
                        if (!$pct_ende) { 
                            $this->Cell(array_sum($w),6,'','T'); 
                        } else {
                            $this->Cell(array_sum($w),6,"");
                        }
                        $pct_ende=1;
                    }
                    $this->Cell($abstand,6,"",'',0,'L',0);



                    // evt
                    if ($evt_data[$aktuelleZeile+$tabellenzeile][0]!='') {
                        for ($j=0;$j<2;$j++) {
                            $this->Cell($w[$j],6,utf8_decode($evt_data[$aktuelleZeile+$tabellenzeile][$j]),'LR',0,'L',$fill);
                        }
                    } else {
                        if (!$evt_ende) { 
                            $this->Cell(array_sum($w),6,'','T'); 
                        } else {
                            $this->Cell(array_sum($w),6,"");
                        }
                        $evt_ende=1;
                    }



                    $this->Ln();
                    $fill=!$fill;
                //}
                
            }
            
            // tabellen schlusslinien
            
            if (!$knd_ende) { 
                $this->Cell(array_sum($w),0,'','T'); 
            } else {
                $this->Cell(array_sum($w),0,'');
            }
            
            $this->Cell($abstand,0,'');


            if (!$pct_ende) { 
                $this->Cell(array_sum($w),0,'','T'); 
            } else {
                $this->Cell(array_sum($w),0,'');
            }
            
            $this->Cell($abstand,0,'');
            
            
            if (!$evt_ende) { 
                $this->Cell(array_sum($w),0,'','T'); 
            } else {
                $this->Cell(array_sum($w),0,'');
            }
            
            $aktuelleZeile+=$maxZeilen;
            if ($aktuelleSeite<$seitenGes) {
                $this->AddPage();
            }
        }
    }




}


?>