/**
 * This file is part of 
 * Kimai - Time Tracking For Designers // http://www.kimai.org
 * (c) 2006/07 Torsten Hoeltge
 * 
 * Kimai is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; Version 2 of June 1991.
 * 
 * Kimai is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Kimai; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

function opera_widthpatch() {
    if($.browser.opera) { 
        $( function() { $("#projectselection table").css({ "width": "100%" }); }); 
    }    
}

// ----------------------------------------------------------------------------------------
// fits the GUI perfectly to the window-size
//
function tableheight(){
    // by V.v.Gemert
    bheight = document.body.clientHeight;
    hheight = document.getElementById('header').clientHeight;

    // If the height of the body is less than 600px change the height of the project tables, 
    if (bheight<670) theight = (bheight-70)/3;
    // else the height is 200px
    else theight = 200;
    
    if($.browser.opera) { 
        bheight-=15; 
    }
    
    opera_widthpatch();
    
    // set the height of the projectdiv
    $("#projectselection").css({height:theight+'px'});

    // Set the height of the childDivs of the projectdiv
    $("#projectselection .subject").css({height:theight+'px'});

    eheight = bheight-hheight-30-theight;
    $("#entries").css({height:eheight+4+'px'});
    $("#entries table").css({height:'auto'});
    $("#entries tbody").css({height:'auto'});
}


// ----------------------------------------------------------------------------------------
// shows dialogues above the GUI
// 
function overlay_show(source,id,width,height) {
    $('a').blur();
    //$(this).addClass("butt_on"); *** doesn't work :-? even though it is correct syntax (?) -> therefore the switch construct ... ***
    switch (source) {
        case 'admin': 
            $("#butt_admin").addClass("butt_on");
            break;
        case 'Credits': 
            $("#butt_about").addClass("butt_on");
            break;      
        case 'Prefs': 
            $("#butt_pref").addClass("butt_on");
            break;      
    }
    $.post("processor.php", 
        { ax: source, id: id },
        function(response){
            
            $("#projectselection div").css({ overflow:"hidden" });
            $("#entries").css({ overflow:"hidden" });
            $("#overlay").html(response);
            if (source=="admin") {
                $('#tabs').tabs();
            }
            $("#overlay").css({ height:"100%", width:"100%", visibility: "visible" });
            $("#container").hide();
            if (width>0 && height>0) {
                bheight = document.body.clientHeight;
                topmargin = (bheight-height)/2;
                $("#container").css({ 'margin-top': topmargin+"px" });
                $("#container").css({ 'min-height': height+"px", height: height+"px", width: width+"px" });
            }
            $("#container").show();
            $("#overlay .hint").hide();
            
            $("#butt_admin").removeClass("butt_on");
            $("#butt_about").removeClass("butt_on");
            $("#butt_pref").removeClass("butt_on");
            
            init_epick(); // initializes DatePickers in record edit
            
        }
    );
}

// ----------------------------------------------------------------------------------------
// hides dialogue again
// 
function overlay_hide() {
    $("#container").hide();
    $("#projectselection div").css({ overflow:"auto" });
    $("#overlay").html('');
    $("#overlay").css({ height:"1%", width:"1%", visibility: "hidden" });
    $("#entries").css({ overflow:"auto" });
}

// ----------------------------------------------------------------------------------------
// shows comment line for timesheet entry
//
function comment(id) {
    $('a').blur();
    $("#c"+id).toggle();
    return false;
}

// ----------------------------------------------------------------------------------------
// pastes the current date and time in the outPoint field of the
// change dialoge for timesheet entries 
//
//         $tpl->assign('pasteValue', date("d.m.Y - H:i:s",$now));
//
function pasteNow(value) {
    $('a').blur();
    
    now = new Date();
    
    d = now.getDate();
    m = now.getMonth()+1;
    Y = now.getFullYear();

    H = now.getHours();
    i = now.getMinutes();
    s = now.getSeconds();
    
    date  = d  + "." + m + "." + Y;
    time  = H + ":" + i + ":" + s;
    
    $("#edit_out").val(date);
    $("#edit_out_time").val(time);
}

// ----------------------------------------------------------------------------------------
// runs the stopwatch
// 
function ticktac() {
    var quartz;
    try {
        current_seconds=new Date();
        current_seconds=current_seconds.getSeconds();
        if (quartz!=current_seconds) { quartz=current_seconds; sec++; }
        if (sec==60) { sec=0; min++; }
        if (min > 59) { min = 0; hour++; }
        if (sec==0) $("#s").html("00"); 
        else {
            $("#s").html(sec); stmp = $("#s").html();
            if (stmp.length<2) $("#s").html("0"+stmp);
        }
        if (min==0) $("#m").html("00");
        else {
            $("#m").html(min); mtmp = $("#m").html();
            if (mtmp.length<2) $("#m").html("0"+mtmp);
        }
        if (hour==0) $("#h").html("00");
        else {
            $("#h").html(hour); htmp = $("#h").html();
            if (htmp.length<2) $("#h").html("0"+htmp);
        }
    setTimeout("ticktac()", 1000);
    } catch (ex) {}
}

// ----------------------------------------------------------------------------------------
// runs the normal watch
// 
var ZeitString, DatumsString = "";
function n_uhr() {
        Jetzt = new Date();
        //aktuelle Uhrzeit
        Stunden = Jetzt.getHours();
        Minuten = Jetzt.getMinutes();
        Sekunden = Jetzt.getSeconds();
        
        // um 00:00 neues Datum zeigen
        trigger = Stunden+Minuten+Sekunden;
        if (trigger==0) {
            $('#display_day').html(nextday);
        }
        
        ZeitString = Stunden;
        
        if (Stunden < 10) {
            ZeitString = "0" + Stunden;
        }
        
        if (Sekunden%2==0) {
            ZeitString += ((Minuten < 10) ? "<span style=\"color:#eee;\">:</span>0" : "<span style=\"color:#eee;\">:</span>") + Minuten;
        } else {
            ZeitString += ((Minuten < 10) ? ":0" : ":") + Minuten;
        }
        //ZeitString += ((Minuten < 10) ? ":0" : ":") + Minuten;
        //ZeitString += ((Sekunden < 10) ? ":0" : ":") + Sekunden;
        $('#n_uhr').html(ZeitString);
        setTimeout("n_uhr()", 1000);
}

// ----------------------------------------------------------------------------------------
// asigns the '.active' styles to the timerdiv and
// tells the stopwatch to count
//
function tellWatchToBeRecording() {
    $("#timer").removeClass();
    $("#timer").addClass("active");
    setTimeout("ticktac()", 1000);
}

// ----------------------------------------------------------------------------------------
// reloads customer, project or event table after finished AJAX request
//
function reloadSubject(subject) {
    switch (subject) {
        case "zef":
            $("#entries table thead tr th").css( { background: "url(../skins/" + skin + "/grfx/header_blink.gif) repeat-x" } );
            $.post("processor.php", { ax: "zef" },
                function(data){
                    $("#entries").html(data);
                    opera_widthpatch();
                    
                    zeige = $("#viewtotal_bottom").html();
                    $("#viewtotal_top").html(zeige);
                }
            );
        break;
        case "knd":
            $("#clientTable table thead tr th").css( { background: "url(../skins/" + skin + "/grfx/header_blink.gif) repeat-x" } );
            $.post("processor.php", { ax: "knd" },
                function(data){
                    $("#clientTable").html(data);
                    opera_widthpatch();
                }
            );
        break;
        case "pct": 
            $("#projectTable table thead tr th").css( { background: "url(../skins/" + skin + "/grfx/header_blink.gif) repeat-x" } );
            $.post("processor.php", { ax: "pct" },
                function(data){
                    $("#projectTable").html(data);
                    opera_widthpatch();
                }
            );
            $("#pctselect").load("processor.php?ax=selPct");
        break;
        case "evt": 
            $("#actionTable table thead tr th").css( { background: "url(../skins/" + skin + "/grfx/header_blink.gif) repeat-x" } );
            $.post("processor.php", { ax: "evt" },
                function(data){
                    $("#actionTable").html(data);
                    opera_widthpatch();
                }
            );
            $("#evtselect").load("processor.php?ax=selEvt");
        break;
    }
    

}
function reloadAllTables() {
    reloadSubject("zef");
    reloadSubject("knd");
    reloadSubject("pct");
    reloadSubject("evt");
}

// ----------------------------------------------------------------------------------------
// returns target div ID for AJAX
//
function getTarget(subject) {
    switch(subject) {
        case 'knd': target = "#clientTable";  break;
        case 'pct': target = "#projectTable"; break;
        case 'evt': target = "#actionTable";  break;
    }
    return target;
}

// ----------------------------------------------------------------------------------------
// displays a dialogue for adding a new item in either the 
// customer, project or event subwindows 
//
function add(subject) {
    target = getTarget(subject);
    $(target).load("processor.php?ax=add&subject="+subject);
}

// ----------------------------------------------------------------------------------------
// calls up AJAX request to write a new item into the customer list
//
function add_knd_go() {
    knd = $("#knd_hinzu").val();
    $.post("processor.php", { ax: "add", knd: knd },
        function(){
            reloadSubject("knd");
            reloadSubject("pct");
        }
    );
}

// ----------------------------------------------------------------------------------------
// calls up AJAX request to write a new item into the project list
//
function add_pct_go() {
    knd_ID = $("#pct_hinzu_knd").val();
    if (!knd_ID) {
        alert ("You have to attach a customer to the project. Choose one from the list before you hit OK.");
    } else {
        pct = $("#pct_hinzu").val();
        $.post("processor.php", { ax: "add", pct: pct, knd_ID: knd_ID },
            function(){ reloadSubject("pct") }
        );
    }
}

// ----------------------------------------------------------------------------------------
// calls up AJAX request to write a new item into the events list
//
function add_evt_go() {
    evt = $("#evt_hinzu").val();
    $.post("processor.php", { ax: "add", evt: evt },
        function(){ reloadSubject("evt") }
    );
}

// ----------------------------------------------------------------------------------------
// displays the hourglass in the upper right corner when the bumper is hidden
//
function Eieruhr() {
    $("#bumper").attr("onClick","return false;");
    $("#bumper").blur();
    $("#bumper").css( { background: "url(../skins/" + skin + "/grfx/eieruhr.gif) no-repeat" } )
}

// ----------------------------------------------------------------------------------------
// starts a new recording task when the start-bumper is hidden
//
function startRecord() {
	Eieruhr();
    $("#pctselect, #evtselect").hide();
    hour=0;min=0;sec=0;
    $.post("processor.php", 
        { ax: "record", pct: $("#pct").val(), evt: $("#evt").val() },
        function(){
            reloadSubject("zef");
            $("#timer").load("processor.php?ax=showStop");
            tellWatchToBeRecording();
        }
    );
}

// ----------------------------------------------------------------------------------------
// stops the current recording task when the stop-bumper is hidden
//
function stopRecord() {
    Eieruhr();
    $("#runningtime").hide();
    $.post("processor.php", { ax: "stop" },
        function(){
            reloadAllTables();
            $("#timer").load("processor.php?ax=showRecord");
            $("#timer").removeClass();
            $("#timer").addClass("inactive");
        }
    );
}

// ----------------------------------------------------------------------------------------
// this function is attached to the little green arrows in front of each timesheet record
// and starts recording that event anew
//
function recordAgain(pct,evt) {
	Eieruhr();
    $("#pctselect, #evtselect").hide();
    hour=0;min=0;sec=0;
    $.post("processor.php", { ax: "record", pct: pct, evt: evt },
        function(){
            reloadSubject("zef");
            $("#timer").load("processor.php?ax=showStop");
            $("#timer").removeClass();
            $("#timer").addClass("active");
            setTimeout("ticktac()", 1000);
        }
    );
}

// ----------------------------------------------------------------------------------------
// cancel button for the add *and* edit dialogues within the sub windows
//
function add_abort(subject) {
    target = getTarget(subject);
    $.post("processor.php", { ax: subject },
        function(data){
            $(target).html(data);
            opera_widthpatch();
        }
    );
}

// ----------------------------------------------------------------------------------------
// shows dialogue for adding a new item to customer, project and event lists
//
function add(subject) {
    target = getTarget(subject);
    $.post("processor.php", { ax: "add", subject: subject },
        function(data){
            $(target).html(data);
            $("#"+subject+"_hinzu").focus();
        }
    );
}

// ----------------------------------------------------------------------------------------
// creates empty new timesheet entry
//
function add_zef() {
    alert('neuen eintrag manuell anlegen');
}


// ----------------------------------------------------------------------------------------
// shows dialogue for editing an item in either customer, project or event list
//
function edit(subject,id,knd_ID) {
    target = getTarget(subject);
    $.post("processor.php", { ax: "edit", subject: subject, id: id, knd_ID: knd_ID },
    function(data){ 
        $(target).html(data);
        $("#"+subject+"_edit").focus();
    });
}

// ----------------------------------------------------------------------------------------
// admin panel - by clicking on the edit button of a user the edit dialogue pops up
//
function editUsr(id) {
    $.post("processor.php", { ax: "admin", tab: "users", action: "editUsr", id: id},
        function(data) {
            $("#users .content").html(data);
        }
    );
}

// ----------------------------------------------------------------------------------------
// admin panel - by clicking on the edit button of a group the edit dialogue pops up
//
function editGrp(id) {
    $.post("processor.php", { ax: "admin", tab: "groups", action: "editGrp", id: id},
        function(data) {
            $("#groups .content").html(data);
        }
    );
}


// ----------------------------------------------------------------------------------------
// calls up AJAX request to update item in customer, project and event lists 
//
function edit_go(subject) {
    item_name = $("#"+subject+"_edit").val();
    item_id   = $("#"+subject+"_id").val();
    
    if (subject == "pct") { 
        knd_ID = $("#pct_edit_knd").val();
    } else { 
        knd_ID = "0";
    }
    
    $.post("processor.php", { ax: "edit", edit: "1", subject: subject, id: item_id, value: item_name, knd_ID: knd_ID }, 
        function() {
            if (subject == "knd") {
                reloadSubject("pct");
            }
            reloadSubject(subject);
            reloadSubject("zef");
        }
    );
}


// ----------------------------------------------------------------------------------------
// calls up AJAX request to update preferences for specific user 
//
function edit_prefs_go() {
    selectskin    = $("#selectskin").val();
    password      = $("#password").val();
    rowlimit      = $("#rowlimit").val();
    lang          = $("#lang").val();

    autoselection = $("#autoselection").attr("checked");
    if (autoselection == true) {
        autoselection=1;
    } else {
        autoselection=0;
    }

    quickdelete = $("#quickdelete").attr("checked");
    if (quickdelete == true) {
        quickdelete=1;
    } else {
        quickdelete=0;
    }

    $.post("processor.php", { ax: "editPrefs", skin: selectskin, password: password, rowlimit: rowlimit, autoselection: autoselection, quickdelete: quickdelete, lang: lang },
        function() { 
            window.location.reload();
        }
    );
}

// ----------------------------------------------------------------------------------------
// calls up AJAX request to update preferences for specific user 
//
function edit_advanced_go() {
    loginmode    = $("#loginmode").val();
    adminmail    = $("#adminmail").val();
    logintries   = $("#logintries").val();
    loginbantime = $("#loginbantime").val();
    charset      = $("#charset").val();
    $.post("processor.php", { 
                                ax: "admin",
                                tab: "advanced",
                                adminmail: adminmail, 
                                logintries: logintries, 
                                loginbantime: loginbantime,
                                charset: charset
                            }, 
        function(data) { 
            //window.location.reload();
            $("#advanced .content").html(data);
        }
    );
}

// ----------------------------------------------------------------------------------------
// sends entries made in the edit entry dialogue via ajax
//
function edit_record_go() {
    $.post("processor.php",
        { ax: 'writeRecord',
          id:  $("#id").val(),
          pct: $("#edit_pct").val(),
          evt: $("#edit_evt").val(),
          edit_in: $("#edit_in").val(),
          edit_out: $("#edit_out").val(),
          edit_in_time: $("#edit_in_time").val(),
          edit_out_time: $("#edit_out_time").val(),
          erase: $("#erase").attr("checked"),
          comment: $("#comment").val(),
          comment_type: $("#comment_type").val()
        },
        function(response){
            $("#overlay").html(response);
            reloadAllTables();
        }
    );
    overlay_hide();
}

// ----------------------------------------------------------------------------------------
// sends entries made in the add entry dialogue via ajax
//
function add_record_go() {
    $.post("processor.php",
        { ax: 'writeRecord',
          pct: $("#edit_pct").val(),
          evt: $("#edit_evt").val(),
          edit_in: $("#edit_in").val(),
          edit_out: $("#edit_out").val(),
          edit_in_time: $("#edit_in_time").val(),
          edit_out_time: $("#edit_out_time").val(),
          comment: $("#comment").val(),
          comment_type: $("#comment_type").val(),
          add: '1'
        },
        function(response){
            $("#overlay").html(response);
            reloadAllTables();
        }
    );
    overlay_hide();
}


// ----------------------------------------------------------------------------------------
// calls up AJAX request to delete a timesheet record
//
function quickdelete(id) {
    $.post("processor.php", { ax: "quickdelete", id: id },
        function(){
            reloadSubject("zef");
        }
    );
}


// ----------------------------------------------------------------------------------------
// if the RETURN key is hit inside a add or edit dialogue this function 
// triggers the OK button
//
function checkKeyPressed(evt,func,params){
  evt = (evt) ? evt : (window.event) ? event : null;
  if (evt) {
    var charCode = (evt.charCode) ? evt.charCode :
                   ((evt.keyCode) ? evt.keyCode :
                   ((evt.which) ? evt.which : 0));
    if (charCode == 13) {
        if (params) func = func+"('"+params+"');";
        eval(func);
    }
  }    
}


// ----------------------------------------------------------------------------------------
// TODO: open dialogue to switch items in customer, project and event lists 
// on and off for display
//
//
function specify(subject) {
    $('a').blur();
    alert("This Button will open a layer like the about-screen. There you can switch items on and off for display - they will not be shown then in the list anymore until you reactivate them via the very same dialogue ...");
}


// ----------------------------------------------------------------------------------------
// calls up AJAX request to erase item in customer, project or event table
//
function erase(subject) {
    id = $("#"+subject+"_id").val();
    $.post("processor.php", { ax: "edit", erase: "1", subject: subject, id: id }, 
        function() {
            reloadSubject(subject)
        }
    );
}

// ----------------------------------------------------------------------------------------
// grabs entered timespace and writes it to database
// after that it reloads all 4 tables
//
function setTimespace() {
    $('#dateGo').blur();
    timespace_in = $("#fromMonth").val() +"-"+ $("#fromDay").val() +"-"+ $("#fromYear").val();
    timespace_out = $("#toMonth").val() +"-"+ $("#toDay").val() +"-"+ $("#toYear").val();
    
    $.post("processor.php", { ax: "set_timespace", timespace_in: timespace_in, timespace_out: timespace_out }, 
        function(data) {
            reloadAllTables();
            
            switch (data) {
                case "0":  in_ok();  out_ok();  break;  // both correct
                case "1":  in_ok();  out_bad(); break;  // out wrong
                case "2":  in_bad(); out_ok();  break;  // in wrong
                case "3":  in_bad(); out_bad(); break;  // both wrong
            }
        }
    );
    
}

function in_bad() {
    $('#fromDay').addClass("datewarning");
    $('#fromMonth').addClass("datewarning");
    $('#fromYear').addClass("datewarning");
}

function out_bad() {
    $('#toDay').addClass("datewarning");
    $('#toMonth').addClass("datewarning");
    $('#toYear').addClass("datewarning");
}

function in_ok() {
    $('#fromDay').removeClass("datewarning");
    $('#fromMonth').removeClass("datewarning");
    $('#fromYear').removeClass("datewarning");
}

function out_ok() {
    $('#toDay').removeClass("datewarning");
    $('#toMonth').removeClass("datewarning");
    $('#toYear').removeClass("datewarning");
}


// temporary function for customer filter
// 16.07.07
function filter(id) {
    $.post("processor.php", { ax: "filter", id: id }, 
        function() {
            reloadSubject('knd');
        }
    );
}



// ----------------------------------------------------------------------------------------
// for admin overlay window
//
function newUser() {
    newuser = $("#newuser").val();
    $.post("processor.php", {ax: "admin", tab: "users", newuser: newuser}, 
    function(data) {
        editUsr(data);
    });
    
}

// ----------------------------------------------------------------------------------------
// for admin overlay window
//
function newGroup() {
    newgroup = $("#newgroup").val();
    $.post("processor.php", {ax: "admin", tab: "groups", newgroup: newgroup}, 
    function(data) {
        $("#groups .content").html(data);
    });
}


function banUsr(id) {
    $("#ban"+id).blur();
    $("#ban"+id).html("<img border=0 src='../skins/"+skin+"/grfx/loading.gif'/>");
    $.post("processor.php", {ax: "ajax_admin", ban: id}, 
        function(data) {
            $("#ban"+id).html(data);
            $("#ban"+id).attr({ onclick: "unbanUsr('"+id+"'); return false;" });
        }
    );
}

function unbanUsr(id) {
    $("#ban"+id).blur();
    $("#ban"+id).html("<img border=0 src='../skins/"+skin+"/grfx/loading.gif'/>");
    $.post("processor.php", {ax: "ajax_admin", unban: id}, 
        function(data) {
            $("#ban"+id).html(data);
            $("#ban"+id).attr({ onclick: "banUsr('"+id+"'); return false;" });
        }
    );
}

function deleteUsr(id) {
    $.post("processor.php", {ax: "ajax_admin", del: id}, 
        function(data) {
            if (confirm(data)) {
                $.post("processor.php", {ax: "ajax_admin", delete_usr: id}, 
                    function(data) {
                        show_Userpanel();
                        show_Grouppanel();
                    }
                );
            }
        }
    );
}


// ----------------------------------------------------------------------------------------
// send data from user edit panel to database
//
function send_usrdetails() {
    $.post("processor.php", { 
                                ax: "ajax_admin", 
                                update_usr: $("#usr_ID").val(), 
                                usr_name: $("#usr_name").val(), 
                                usr_sts: $("#usr_sts").val(), 
                                usr_pw: $("#usr_pw").val(), 
                                usr_mail: $("#usr_mail").val(),
                                usr_grp: $("#usr_grp").val()
                             },
        function() {
            show_Userpanel();
            show_Grouppanel();
        }
    );
}

function close_editUsr() {
    show_Userpanel();
}

function show_Userpanel() {
    $.post("processor.php", { ax: "admin", tab: "users"},
        function(data) {
            $("#users .content").html(data);
        }
    );
}    

function switchUsr(id) {
    alert("Under construction...\nUser to switch to: "+id);
}

function backupUsr(id) {
    alert("Under construction...\nUser to backup: "+id);
}

function backupAll() {
    alert("Under construction...");
}

function switchGrp(id) {
    alert("Under construction...\nGroup to switch to: "+id);
}

function backupGrp(id) {
    alert("Under construction...\nGroup to backup: "+id);
}

function deleteGrp(id) {
    $.post("processor.php", {ax: "ajax_admin", del: id}, 
        function(data) {
            if (confirm(data)) {
                $.post("processor.php", {ax: "ajax_admin", delete_grp: id}, 
                    function(data) {
                        show_Grouppanel();
                        show_Userpanel();
                    }
                );
            }
        }
    );
}

function close_editGrp() {
    show_Grouppanel();
}

function show_Grouppanel() {
    $.post("processor.php", { ax: "admin", tab: "groups"},
        function(data) {
            $("#groups .content").html(data);
        }
    );
}    

// ----------------------------------------------------------------------------------------
// send data from group edit panel to database
//
function send_grpdetails() {
    $.post("processor.php", { 
                                ax: "ajax_admin", 
                                update_grp: $("#grp_ID").val(), 
                                grp_name: $("#grp_name").val(), 
                                grp_leader: $("#grp_leader").val()
                             },
        function() {
            show_Grouppanel();
            show_Userpanel();
        }
    );
}
